use v6;

use WebService::GitHub::Role;
use WebService::GitHub::GraphQL;
use WebService::GitHub::Git::Commits;
use WebService::GitHub::Teams::Members;
use WebService::GitHub::EnterpriseAdmin::AuditLog;
use WebService::GitHub::Interactions::User;
use WebService::GitHub::Activity::Notifications;
use WebService::GitHub::Interactions::Orgs;
use WebService::GitHub::Apps::Installations;
use WebService::GitHub::Reactions;
use WebService::GitHub::Actions::WorkflowJobs;
use WebService::GitHub::Users::Keys;
use WebService::GitHub::Orgs::Webhooks;
use WebService::GitHub::Repos;
use WebService::GitHub::Markdown;
use WebService::GitHub::Repos::Statistics;
use WebService::GitHub::Activity::Events;
use WebService::GitHub::OauthAuthorizations;
use WebService::GitHub::Actions::SelfHostedRunnerGroups;
use WebService::GitHub::Repos::Statuses;
use WebService::GitHub::Orgs::Blocking;
use WebService::GitHub::Repos::Pages;
use WebService::GitHub::Migrations::Orgs;
use WebService::GitHub::Repos::Keys;
use WebService::GitHub::Actions::Permissions;
use WebService::GitHub::CodesOfConduct;
use WebService::GitHub::Repos::Environments;
use WebService::GitHub::SecretScanning;
use WebService::GitHub::Gists;
use WebService::GitHub::Gists::Comments;
use WebService::GitHub::Orgs::OutsideCollaborators;
use WebService::GitHub::Actions::WorkflowRuns;
use WebService::GitHub::Apps::Marketplace;
use WebService::GitHub::Issues::Timeline;
use WebService::GitHub::Repos::Invitations;
use WebService::GitHub::Repos::Collaborators;
use WebService::GitHub::Teams::TeamSync;
use WebService::GitHub::Licenses;
use WebService::GitHub::Pulls::Reviews;
use WebService::GitHub::Repos::Releases;
use WebService::GitHub::Checks::Suites;
use WebService::GitHub::Checks::Runs;
use WebService::GitHub::Git::Trees;
use WebService::GitHub::Repos::Contents;
use WebService::GitHub::Meta;
use WebService::GitHub::Teams::DiscussionComments;
use WebService::GitHub::Packages;
use WebService::GitHub::Apps::OauthApplications;
use WebService::GitHub::Issues::Labels;
use WebService::GitHub::Pulls::Comments;
use WebService::GitHub::Activity::Feeds;
use WebService::GitHub::Repos::Branches;
use WebService::GitHub::Activity::Watching;
use WebService::GitHub::Actions::Secrets;
use WebService::GitHub::Repos::Deployments;
use WebService::GitHub::Issues;
use WebService::GitHub::Teams::Discussions;
use WebService::GitHub::Repos::Commits;
use WebService::GitHub::Billing;
use WebService::GitHub::Issues::Milestones;
use WebService::GitHub::Git::Blobs;
use WebService::GitHub::Search;
use WebService::GitHub::EnterpriseAdmin::Billing;
use WebService::GitHub::Activity::Starring;
use WebService::GitHub::Apps::Webhooks;
use WebService::GitHub::Apps;
use WebService::GitHub::Migrations::SourceImports;
use WebService::GitHub::Actions::Workflows;
use WebService::GitHub::Issues::Comments;
use WebService::GitHub::Gitignore;
use WebService::GitHub::Projects::Cards;
use WebService::GitHub::Actions::SelfHostedRunners;
use WebService::GitHub::Users::GpgKeys;
use WebService::GitHub::Issues::Events;
use WebService::GitHub::EnterpriseAdmin::Actions;
use WebService::GitHub::CodeScanning;
use WebService::GitHub::Repos::Forks;
use WebService::GitHub::Emojis;
use WebService::GitHub::Teams;
use WebService::GitHub::Pulls;
use WebService::GitHub::Git::Refs;
use WebService::GitHub::Migrations::Users;
use WebService::GitHub::Pulls::ReviewRequests;
use WebService::GitHub::Users::Emails;
use WebService::GitHub::Users;
use WebService::GitHub::Projects;
use WebService::GitHub::Git::Tags;
use WebService::GitHub::Users::Followers;
use WebService::GitHub::RateLimit;
use WebService::GitHub::Repos::Comments;
use WebService::GitHub::Orgs::Members;
use WebService::GitHub::Repos::Community;
use WebService::GitHub::Actions::Artifacts;
use WebService::GitHub::EnterpriseAdmin::Scim;
use WebService::GitHub::Orgs;
use WebService::GitHub::Issues::Assignees;
use WebService::GitHub::Interactions::Repos;
use WebService::GitHub::Projects::Columns;
use WebService::GitHub::Repos::Merging;
use WebService::GitHub::Users::Blocking;
use WebService::GitHub::Repos::Webhooks;
use WebService::GitHub::Scim;
use WebService::GitHub::Projects::Collaborators;
use WebService::GitHub::Repos::Traffic;

class WebService::GitHub does WebService::GitHub::Role {
    # does WebService::GitHub::Role::Debug if %*ENV<DEBUG_GITHUB>;

    method graphql() {
        state $obj = WebService::GitHub::GraphQL.new: |self!attrs;
        $obj;
    }

    method git-commits() {
        state $obj = WebService::GitHub::Git::Commits.new: |self!attrs;
        $obj;
    }
    method teams-members() {
        state $obj = WebService::GitHub::Teams::Members.new: |self!attrs;
        $obj;
    }
    method enterpriseadmin-auditlog() {
        state $obj = WebService::GitHub::EnterpriseAdmin::AuditLog.new: |self!attrs;
        $obj;
    }
    method interactions-user() {
        state $obj = WebService::GitHub::Interactions::User.new: |self!attrs;
        $obj;
    }
    method activity-notifications() {
        state $obj = WebService::GitHub::Activity::Notifications.new: |self!attrs;
        $obj;
    }
    method interactions-orgs() {
        state $obj = WebService::GitHub::Interactions::Orgs.new: |self!attrs;
        $obj;
    }
    method apps-installations() {
        state $obj = WebService::GitHub::Apps::Installations.new: |self!attrs;
        $obj;
    }
    method reactions() {
        state $obj = WebService::GitHub::Reactions.new: |self!attrs;
        $obj;
    }
    method actions-workflowjobs() {
        state $obj = WebService::GitHub::Actions::WorkflowJobs.new: |self!attrs;
        $obj;
    }
    method users-keys() {
        state $obj = WebService::GitHub::Users::Keys.new: |self!attrs;
        $obj;
    }
    method orgs-webhooks() {
        state $obj = WebService::GitHub::Orgs::Webhooks.new: |self!attrs;
        $obj;
    }
    method repos() {
        state $obj = WebService::GitHub::Repos.new: |self!attrs;
        $obj;
    }
    method markdown() {
        state $obj = WebService::GitHub::Markdown.new: |self!attrs;
        $obj;
    }
    method repos-statistics() {
        state $obj = WebService::GitHub::Repos::Statistics.new: |self!attrs;
        $obj;
    }
    method activity-events() {
        state $obj = WebService::GitHub::Activity::Events.new: |self!attrs;
        $obj;
    }
    method oauthauthorizations() {
        state $obj = WebService::GitHub::OauthAuthorizations.new: |self!attrs;
        $obj;
    }
    method actions-selfhostedrunnergroups() {
        state $obj = WebService::GitHub::Actions::SelfHostedRunnerGroups.new: |self!attrs;
        $obj;
    }
    method repos-statuses() {
        state $obj = WebService::GitHub::Repos::Statuses.new: |self!attrs;
        $obj;
    }
    method orgs-blocking() {
        state $obj = WebService::GitHub::Orgs::Blocking.new: |self!attrs;
        $obj;
    }
    method repos-pages() {
        state $obj = WebService::GitHub::Repos::Pages.new: |self!attrs;
        $obj;
    }
    method migrations-orgs() {
        state $obj = WebService::GitHub::Migrations::Orgs.new: |self!attrs;
        $obj;
    }
    method repos-keys() {
        state $obj = WebService::GitHub::Repos::Keys.new: |self!attrs;
        $obj;
    }
    method actions-permissions() {
        state $obj = WebService::GitHub::Actions::Permissions.new: |self!attrs;
        $obj;
    }
    method codesofconduct() {
        state $obj = WebService::GitHub::CodesOfConduct.new: |self!attrs;
        $obj;
    }
    method repos-environments() {
        state $obj = WebService::GitHub::Repos::Environments.new: |self!attrs;
        $obj;
    }
    method secretscanning() {
        state $obj = WebService::GitHub::SecretScanning.new: |self!attrs;
        $obj;
    }
    method gists() {
        state $obj = WebService::GitHub::Gists.new: |self!attrs;
        $obj;
    }
    method gists-comments() {
        state $obj = WebService::GitHub::Gists::Comments.new: |self!attrs;
        $obj;
    }
    method orgs-outsidecollaborators() {
        state $obj = WebService::GitHub::Orgs::OutsideCollaborators.new: |self!attrs;
        $obj;
    }
    method actions-workflowruns() {
        state $obj = WebService::GitHub::Actions::WorkflowRuns.new: |self!attrs;
        $obj;
    }
    method apps-marketplace() {
        state $obj = WebService::GitHub::Apps::Marketplace.new: |self!attrs;
        $obj;
    }
    method issues-timeline() {
        state $obj = WebService::GitHub::Issues::Timeline.new: |self!attrs;
        $obj;
    }
    method repos-invitations() {
        state $obj = WebService::GitHub::Repos::Invitations.new: |self!attrs;
        $obj;
    }
    method repos-collaborators() {
        state $obj = WebService::GitHub::Repos::Collaborators.new: |self!attrs;
        $obj;
    }
    method teams-teamsync() {
        state $obj = WebService::GitHub::Teams::TeamSync.new: |self!attrs;
        $obj;
    }
    method licenses() {
        state $obj = WebService::GitHub::Licenses.new: |self!attrs;
        $obj;
    }
    method pulls-reviews() {
        state $obj = WebService::GitHub::Pulls::Reviews.new: |self!attrs;
        $obj;
    }
    method repos-releases() {
        state $obj = WebService::GitHub::Repos::Releases.new: |self!attrs;
        $obj;
    }
    method checks-suites() {
        state $obj = WebService::GitHub::Checks::Suites.new: |self!attrs;
        $obj;
    }
    method checks-runs() {
        state $obj = WebService::GitHub::Checks::Runs.new: |self!attrs;
        $obj;
    }
    method git-trees() {
        state $obj = WebService::GitHub::Git::Trees.new: |self!attrs;
        $obj;
    }
    method repos-contents() {
        state $obj = WebService::GitHub::Repos::Contents.new: |self!attrs;
        $obj;
    }
    method meta() {
        state $obj = WebService::GitHub::Meta.new: |self!attrs;
        $obj;
    }
    method teams-discussioncomments() {
        state $obj = WebService::GitHub::Teams::DiscussionComments.new: |self!attrs;
        $obj;
    }
    method packages() {
        state $obj = WebService::GitHub::Packages.new: |self!attrs;
        $obj;
    }
    method apps-oauthapplications() {
        state $obj = WebService::GitHub::Apps::OauthApplications.new: |self!attrs;
        $obj;
    }
    method issues-labels() {
        state $obj = WebService::GitHub::Issues::Labels.new: |self!attrs;
        $obj;
    }
    method pulls-comments() {
        state $obj = WebService::GitHub::Pulls::Comments.new: |self!attrs;
        $obj;
    }
    method activity-feeds() {
        state $obj = WebService::GitHub::Activity::Feeds.new: |self!attrs;
        $obj;
    }
    method repos-branches() {
        state $obj = WebService::GitHub::Repos::Branches.new: |self!attrs;
        $obj;
    }
    method activity-watching() {
        state $obj = WebService::GitHub::Activity::Watching.new: |self!attrs;
        $obj;
    }
    method actions-secrets() {
        state $obj = WebService::GitHub::Actions::Secrets.new: |self!attrs;
        $obj;
    }
    method repos-deployments() {
        state $obj = WebService::GitHub::Repos::Deployments.new: |self!attrs;
        $obj;
    }
    method issues() {
        state $obj = WebService::GitHub::Issues.new: |self!attrs;
        $obj;
    }
    method teams-discussions() {
        state $obj = WebService::GitHub::Teams::Discussions.new: |self!attrs;
        $obj;
    }
    method repos-commits() {
        state $obj = WebService::GitHub::Repos::Commits.new: |self!attrs;
        $obj;
    }
    method billing() {
        state $obj = WebService::GitHub::Billing.new: |self!attrs;
        $obj;
    }
    method issues-milestones() {
        state $obj = WebService::GitHub::Issues::Milestones.new: |self!attrs;
        $obj;
    }
    method git-blobs() {
        state $obj = WebService::GitHub::Git::Blobs.new: |self!attrs;
        $obj;
    }
    method search() {
        state $obj = WebService::GitHub::Search.new: |self!attrs;
        $obj;
    }
    method enterpriseadmin-billing() {
        state $obj = WebService::GitHub::EnterpriseAdmin::Billing.new: |self!attrs;
        $obj;
    }
    method activity-starring() {
        state $obj = WebService::GitHub::Activity::Starring.new: |self!attrs;
        $obj;
    }
    method apps-webhooks() {
        state $obj = WebService::GitHub::Apps::Webhooks.new: |self!attrs;
        $obj;
    }
    method apps() {
        state $obj = WebService::GitHub::Apps.new: |self!attrs;
        $obj;
    }
    method migrations-sourceimports() {
        state $obj = WebService::GitHub::Migrations::SourceImports.new: |self!attrs;
        $obj;
    }
    method actions-workflows() {
        state $obj = WebService::GitHub::Actions::Workflows.new: |self!attrs;
        $obj;
    }
    method issues-comments() {
        state $obj = WebService::GitHub::Issues::Comments.new: |self!attrs;
        $obj;
    }
    method gitignore() {
        state $obj = WebService::GitHub::Gitignore.new: |self!attrs;
        $obj;
    }
    method projects-cards() {
        state $obj = WebService::GitHub::Projects::Cards.new: |self!attrs;
        $obj;
    }
    method actions-selfhostedrunners() {
        state $obj = WebService::GitHub::Actions::SelfHostedRunners.new: |self!attrs;
        $obj;
    }
    method users-gpgkeys() {
        state $obj = WebService::GitHub::Users::GpgKeys.new: |self!attrs;
        $obj;
    }
    method issues-events() {
        state $obj = WebService::GitHub::Issues::Events.new: |self!attrs;
        $obj;
    }
    method enterpriseadmin-actions() {
        state $obj = WebService::GitHub::EnterpriseAdmin::Actions.new: |self!attrs;
        $obj;
    }
    method codescanning() {
        state $obj = WebService::GitHub::CodeScanning.new: |self!attrs;
        $obj;
    }
    method repos-forks() {
        state $obj = WebService::GitHub::Repos::Forks.new: |self!attrs;
        $obj;
    }
    method emojis() {
        state $obj = WebService::GitHub::Emojis.new: |self!attrs;
        $obj;
    }
    method teams() {
        state $obj = WebService::GitHub::Teams.new: |self!attrs;
        $obj;
    }
    method pulls() {
        state $obj = WebService::GitHub::Pulls.new: |self!attrs;
        $obj;
    }
    method git-refs() {
        state $obj = WebService::GitHub::Git::Refs.new: |self!attrs;
        $obj;
    }
    method migrations-users() {
        state $obj = WebService::GitHub::Migrations::Users.new: |self!attrs;
        $obj;
    }
    method pulls-reviewrequests() {
        state $obj = WebService::GitHub::Pulls::ReviewRequests.new: |self!attrs;
        $obj;
    }
    method users-emails() {
        state $obj = WebService::GitHub::Users::Emails.new: |self!attrs;
        $obj;
    }
    method users() {
        state $obj = WebService::GitHub::Users.new: |self!attrs;
        $obj;
    }
    method projects() {
        state $obj = WebService::GitHub::Projects.new: |self!attrs;
        $obj;
    }
    method git-tags() {
        state $obj = WebService::GitHub::Git::Tags.new: |self!attrs;
        $obj;
    }
    method users-followers() {
        state $obj = WebService::GitHub::Users::Followers.new: |self!attrs;
        $obj;
    }
    method ratelimit() {
        state $obj = WebService::GitHub::RateLimit.new: |self!attrs;
        $obj;
    }
    method repos-comments() {
        state $obj = WebService::GitHub::Repos::Comments.new: |self!attrs;
        $obj;
    }
    method orgs-members() {
        state $obj = WebService::GitHub::Orgs::Members.new: |self!attrs;
        $obj;
    }
    method repos-community() {
        state $obj = WebService::GitHub::Repos::Community.new: |self!attrs;
        $obj;
    }
    method actions-artifacts() {
        state $obj = WebService::GitHub::Actions::Artifacts.new: |self!attrs;
        $obj;
    }
    method enterpriseadmin-scim() {
        state $obj = WebService::GitHub::EnterpriseAdmin::Scim.new: |self!attrs;
        $obj;
    }
    method orgs() {
        state $obj = WebService::GitHub::Orgs.new: |self!attrs;
        $obj;
    }
    method issues-assignees() {
        state $obj = WebService::GitHub::Issues::Assignees.new: |self!attrs;
        $obj;
    }
    method interactions-repos() {
        state $obj = WebService::GitHub::Interactions::Repos.new: |self!attrs;
        $obj;
    }
    method projects-columns() {
        state $obj = WebService::GitHub::Projects::Columns.new: |self!attrs;
        $obj;
    }
    method repos-merging() {
        state $obj = WebService::GitHub::Repos::Merging.new: |self!attrs;
        $obj;
    }
    method users-blocking() {
        state $obj = WebService::GitHub::Users::Blocking.new: |self!attrs;
        $obj;
    }
    method repos-webhooks() {
        state $obj = WebService::GitHub::Repos::Webhooks.new: |self!attrs;
        $obj;
    }
    method scim() {
        state $obj = WebService::GitHub::Scim.new: |self!attrs;
        $obj;
    }
    method projects-collaborators() {
        state $obj = WebService::GitHub::Projects::Collaborators.new: |self!attrs;
        $obj;
    }
    method repos-traffic() {
        state $obj = WebService::GitHub::Repos::Traffic.new: |self!attrs;
        $obj;
    }

    # I don't know if this can cause issues, patches are welcome if there is another way to do it
    method !attrs() {
        self.^attributes(:local).map( -> $attr { $attr.name.split('!')[*-1] => $attr.get_value(self) } ).Hash
    }
}

