


use WebService::GitHub::Role;

class WebService::GitHub::Actions::Artifacts  {
    also does WebService::GitHub::Role;
    method delete-artifact(Str $owner, Str $repo, Int(Str) $artifact-id) {
        self.request("/repos/$owner/$repo/actions/artifacts/$artifact-id","DELETE")
    }

    method download-artifact(Str $owner, Str $repo, Int(Str) $artifact-id, Str $archive-format) {
        self.request("/repos/$owner/$repo/actions/artifacts/$artifact-id/$archive-format","GET")
    }

    method get-artifact(Str $owner, Str $repo, Int(Str) $artifact-id) {
        self.request("/repos/$owner/$repo/actions/artifacts/$artifact-id","GET")
    }

    method list-artifacts-for-repo(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/actions/artifacts","GET", :%data)
    }

    method list-workflow-run-artifacts(Str $owner, Str $repo, Int(Str) $run-id, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/actions/runs/$run-id/artifacts","GET", :%data)
    }

}

