

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Actions::SelfHostedRunnerGroups::CreateSelfHostedRunnerGroupForOrgVisibility of Str where subset-is * eq 'selected'|'all'|'private', 'WebService::GitHub::Actions::SelfHostedRunnerGroups::CreateSelfHostedRunnerGroupForOrgVisibility must be either "selected", "all" or "private"';

subset WebService::GitHub::Actions::SelfHostedRunnerGroups::UpdateSelfHostedRunnerGroupForOrgVisibility of Str where subset-is * eq 'selected'|'all'|'private', 'WebService::GitHub::Actions::SelfHostedRunnerGroups::UpdateSelfHostedRunnerGroupForOrgVisibility must be either "selected", "all" or "private"';


class WebService::GitHub::Actions::SelfHostedRunnerGroups  {
    also does WebService::GitHub::Role;
    method add-repo-access-to-self-hosted-runner-group-in-org(Str $org, Int(Str) $runner-group-id, Int(Str) $repository-id) {
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/repositories/$repository-id","PUT")
    }

    method add-self-hosted-runner-to-group-for-org(Str $org, Int(Str) $runner-group-id, Int(Str) $runner-id) {
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/runners/$runner-id","PUT")
    }

    method create-self-hosted-runner-group-for-org(Str $org, Str :$name!, Positional :$selected-repository-ids, WebService::GitHub::Actions::SelfHostedRunnerGroups::CreateSelfHostedRunnerGroupForOrgVisibility :$visibility, Positional :$runners) {
        my %data;
        %data<selected_repository_ids> = $selected-repository-ids if defined $selected-repository-ids;
        %data<visibility> = $visibility if defined $visibility;
        %data<name> = $name;
        %data<runners> = $runners if defined $runners;
        self.request("/orgs/$org/actions/runner-groups","POST", :%data)
    }

    method delete-self-hosted-runner-group-from-org(Str $org, Int(Str) $runner-group-id) {
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id","DELETE")
    }

    method get-self-hosted-runner-group-for-org(Str $org, Int(Str) $runner-group-id) {
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id","GET")
    }

    method list-repo-access-to-self-hosted-runner-group-in-org(Str $org, Int(Str) $runner-group-id, Int(Str) :$page, Int(Str) :$per-page) {
        my %data;
        %data<page> = $page if defined $page;
        %data<per_page> = $per-page if defined $per-page;
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/repositories","GET", :%data)
    }

    method list-self-hosted-runner-groups-for-org(Str $org, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/actions/runner-groups","GET", :%data)
    }

    method list-self-hosted-runners-in-group-for-org(Str $org, Int(Str) $runner-group-id, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/runners","GET", :%data)
    }

    method remove-repo-access-to-self-hosted-runner-group-in-org(Str $org, Int(Str) $runner-group-id, Int(Str) $repository-id) {
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/repositories/$repository-id","DELETE")
    }

    method remove-self-hosted-runner-from-group-for-org(Str $org, Int(Str) $runner-group-id, Int(Str) $runner-id) {
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/runners/$runner-id","DELETE")
    }

    method set-repo-access-to-self-hosted-runner-group-in-org(Str $org, Int(Str) $runner-group-id, Positional :$selected-repository-ids!) {
        my %data;
        %data<selected_repository_ids> = $selected-repository-ids;
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/repositories","PUT", :%data)
    }

    method set-self-hosted-runners-in-group-for-org(Str $org, Int(Str) $runner-group-id, Positional :$runners!) {
        my %data;
        %data<runners> = $runners;
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id/runners","PUT", :%data)
    }

    method update-self-hosted-runner-group-for-org(Str $org, Int(Str) $runner-group-id, Str :$name, WebService::GitHub::Actions::SelfHostedRunnerGroups::UpdateSelfHostedRunnerGroupForOrgVisibility :$visibility) {
        my %data;
        %data<name> = $name if defined $name;
        %data<visibility> = $visibility if defined $visibility;
        self.request("/orgs/$org/actions/runner-groups/$runner-group-id","PATCH", :%data)
    }

}

