


use WebService::GitHub::Role;

class WebService::GitHub::Actions::SelfHostedRunners  {
    also does WebService::GitHub::Role;
    method create-registration-token-for-org(Str $org) {
        self.request("/orgs/$org/actions/runners/registration-token","POST")
    }

    method create-registration-token-for-repo(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/actions/runners/registration-token","POST")
    }

    method create-remove-token-for-org(Str $org) {
        self.request("/orgs/$org/actions/runners/remove-token","POST")
    }

    method create-remove-token-for-repo(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/actions/runners/remove-token","POST")
    }

    method delete-self-hosted-runner-from-org(Str $org, Int(Str) $runner-id) {
        self.request("/orgs/$org/actions/runners/$runner-id","DELETE")
    }

    method delete-self-hosted-runner-from-repo(Str $owner, Str $repo, Int(Str) $runner-id) {
        self.request("/repos/$owner/$repo/actions/runners/$runner-id","DELETE")
    }

    method get-self-hosted-runner-for-org(Str $org, Int(Str) $runner-id) {
        self.request("/orgs/$org/actions/runners/$runner-id","GET")
    }

    method get-self-hosted-runner-for-repo(Str $owner, Str $repo, Int(Str) $runner-id) {
        self.request("/repos/$owner/$repo/actions/runners/$runner-id","GET")
    }

    method list-runner-applications-for-org(Str $org) {
        self.request("/orgs/$org/actions/runners/downloads","GET")
    }

    method list-runner-applications-for-repo(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/actions/runners/downloads","GET")
    }

    method list-self-hosted-runners-for-org(Str $org, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/actions/runners","GET", :%data)
    }

    method list-self-hosted-runners-for-repo(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/actions/runners","GET", :%data)
    }

}

