

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Actions::WorkflowJobs::ListJobsForWorkflowRunFilter of Str where subset-is * eq 'latest'|'all', 'WebService::GitHub::Actions::WorkflowJobs::ListJobsForWorkflowRunFilter must be either "latest" or "all"';


class WebService::GitHub::Actions::WorkflowJobs  {
    also does WebService::GitHub::Role;
    method download-job-logs-for-workflow-run(Str $owner, Str $repo, Int(Str) $job-id) {
        self.request("/repos/$owner/$repo/actions/jobs/$job-id/logs","GET")
    }

    method get-job-for-workflow-run(Str $owner, Str $repo, Int(Str) $job-id) {
        self.request("/repos/$owner/$repo/actions/jobs/$job-id","GET")
    }

    method list-jobs-for-workflow-run(Str $owner, Str $repo, Int(Str) $run-id, WebService::GitHub::Actions::WorkflowJobs::ListJobsForWorkflowRunFilter :$filter, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<filter> = $filter if defined $filter;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/actions/runs/$run-id/jobs","GET", :%data)
    }

}

