


use WebService::GitHub::Role;

class WebService::GitHub::Actions::Workflows  {
    also does WebService::GitHub::Role;
    method create-workflow-dispatch(Str $owner, Str $repo, Any $workflow-id, Str :$ref!, Associative :$inputs) {
        my %data;
        %data<ref> = $ref;
        %data<inputs> = $inputs if defined $inputs;
        self.request("/repos/$owner/$repo/actions/workflows/$workflow-id/dispatches","POST", :%data)
    }

    method disable-workflow(Str $owner, Str $repo, Any $workflow-id) {
        self.request("/repos/$owner/$repo/actions/workflows/$workflow-id/disable","PUT")
    }

    method enable-workflow(Str $owner, Str $repo, Any $workflow-id) {
        self.request("/repos/$owner/$repo/actions/workflows/$workflow-id/enable","PUT")
    }

    method get-workflow(Str $owner, Str $repo, Any $workflow-id) {
        self.request("/repos/$owner/$repo/actions/workflows/$workflow-id","GET")
    }

    method get-workflow-usage(Str $owner, Str $repo, Any $workflow-id) {
        self.request("/repos/$owner/$repo/actions/workflows/$workflow-id/timing","GET")
    }

    method list-repo-workflows(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/actions/workflows","GET", :%data)
    }

}

