


use WebService::GitHub::Role;

class WebService::GitHub::Activity::Events  {
    also does WebService::GitHub::Role;
    method list-events-for-authenticated-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/events","GET", :%data)
    }

    method list-org-events-for-authenticated-user(Str $username, Str $org, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/events/orgs/$org","GET", :%data)
    }

    method list-public-events(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/events","GET", :%data)
    }

    method list-public-events-for-repo-network(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/networks/$owner/$repo/events","GET", :%data)
    }

    method list-public-events-for-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/events/public","GET", :%data)
    }

    method list-public-org-events(Str $org, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/events","GET", :%data)
    }

    method list-received-events-for-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/received_events","GET", :%data)
    }

    method list-received-public-events-for-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/received_events/public","GET", :%data)
    }

    method list-repo-events(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/events","GET", :%data)
    }

}

