


use WebService::GitHub::Role;

class WebService::GitHub::Activity::Notifications  {
    also does WebService::GitHub::Role;
    method delete-thread-subscription(Int(Str) $thread-id) {
        self.request("/notifications/threads/$thread-id/subscription","DELETE")
    }

    method get-thread(Int(Str) $thread-id) {
        self.request("/notifications/threads/$thread-id","GET")
    }

    method get-thread-subscription-for-authenticated-user(Int(Str) $thread-id) {
        self.request("/notifications/threads/$thread-id/subscription","GET")
    }

    method list-notifications-for-authenticated-user(Bool :$all, Bool :$participating, Str :$since, Str :$before, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<all> = $all if defined $all;
        %data<participating> = $participating if defined $participating;
        %data<since> = $since if defined $since;
        %data<before> = $before if defined $before;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/notifications","GET", :%data)
    }

    method list-repo-notifications-for-authenticated-user(Str $owner, Str $repo, Bool :$all, Bool :$participating, Str :$since, Str :$before, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<all> = $all if defined $all;
        %data<participating> = $participating if defined $participating;
        %data<since> = $since if defined $since;
        %data<before> = $before if defined $before;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/notifications","GET", :%data)
    }

    method mark-notifications-as-read(Bool :$read, Str :$last-read-at) {
        my %data;
        %data<read> = $read if defined $read;
        %data<last_read_at> = $last-read-at if defined $last-read-at;
        self.request("/notifications","PUT", :%data)
    }

    method mark-repo-notifications-as-read(Str $owner, Str $repo, Str :$last-read-at) {
        my %data;
        %data<last_read_at> = $last-read-at if defined $last-read-at;
        self.request("/repos/$owner/$repo/notifications","PUT", :%data)
    }

    method mark-thread-as-read(Int(Str) $thread-id) {
        self.request("/notifications/threads/$thread-id","PATCH")
    }

    method set-thread-subscription(Int(Str) $thread-id, Bool :$ignored) {
        my %data;
        %data<ignored> = $ignored if defined $ignored;
        self.request("/notifications/threads/$thread-id/subscription","PUT", :%data)
    }

}

