

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Activity::Starring::ListReposStarredByAuthenticatedUserDirection of Str where subset-is * eq 'asc'|'desc', 'WebService::GitHub::Activity::Starring::ListReposStarredByAuthenticatedUserDirection must be either "asc" or "desc"';

subset WebService::GitHub::Activity::Starring::ListReposStarredByAuthenticatedUserSort of Str where subset-is * eq 'created'|'updated', 'WebService::GitHub::Activity::Starring::ListReposStarredByAuthenticatedUserSort must be either "created" or "updated"';

subset WebService::GitHub::Activity::Starring::ListReposStarredByUserDirection of Str where subset-is * eq 'asc'|'desc', 'WebService::GitHub::Activity::Starring::ListReposStarredByUserDirection must be either "asc" or "desc"';

subset WebService::GitHub::Activity::Starring::ListReposStarredByUserSort of Str where subset-is * eq 'created'|'updated', 'WebService::GitHub::Activity::Starring::ListReposStarredByUserSort must be either "created" or "updated"';


class WebService::GitHub::Activity::Starring  {
    also does WebService::GitHub::Role;
    method check-repo-is-starred-by-authenticated-user(Str $owner, Str $repo) {
        self.request("/user/starred/$owner/$repo","GET")
    }

    method list-repos-starred-by-authenticated-user(WebService::GitHub::Activity::Starring::ListReposStarredByAuthenticatedUserSort :$sort, WebService::GitHub::Activity::Starring::ListReposStarredByAuthenticatedUserDirection :$direction, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<sort> = $sort if defined $sort;
        %data<direction> = $direction if defined $direction;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/starred","GET", :%data)
    }

    method list-repos-starred-by-user(Str $username, WebService::GitHub::Activity::Starring::ListReposStarredByUserSort :$sort, WebService::GitHub::Activity::Starring::ListReposStarredByUserDirection :$direction, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<sort> = $sort if defined $sort;
        %data<direction> = $direction if defined $direction;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/starred","GET", :%data)
    }

    method list-stargazers-for-repo(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/stargazers","GET", :%data)
    }

    method star-repo-for-authenticated-user(Str $owner, Str $repo) {
        self.request("/user/starred/$owner/$repo","PUT")
    }

    method unstar-repo-for-authenticated-user(Str $owner, Str $repo) {
        self.request("/user/starred/$owner/$repo","DELETE")
    }

}

