


use WebService::GitHub::Role;

class WebService::GitHub::Activity::Watching  {
    also does WebService::GitHub::Role;
    method delete-repo-subscription(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/subscription","DELETE")
    }

    method get-repo-subscription(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/subscription","GET")
    }

    method list-repos-watched-by-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/subscriptions","GET", :%data)
    }

    method list-watched-repos-for-authenticated-user(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/subscriptions","GET", :%data)
    }

    method list-watchers-for-repo(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/subscribers","GET", :%data)
    }

    method set-repo-subscription(Str $owner, Str $repo, Bool :$subscribed, Bool :$ignored) {
        my %data;
        %data<subscribed> = $subscribed if defined $subscribed;
        %data<ignored> = $ignored if defined $ignored;
        self.request("/repos/$owner/$repo/subscription","PUT", :%data)
    }

}

