


use WebService::GitHub::Role;

class WebService::GitHub::Apps  {
    also does WebService::GitHub::Role;
    method create-from-manifest(Str $code) {
        self.request("/app-manifests/$code/conversions","POST")
    }

    method create-installation-access-token(Int(Str) $installation-id, Associative :$permissions, Positional :$repositories, Positional :$repository-ids) {
        my %data;
        %data<permissions> = $permissions if defined $permissions;
        %data<repositories> = $repositories if defined $repositories;
        %data<repository_ids> = $repository-ids if defined $repository-ids;
        self.request("/app/installations/$installation-id/access_tokens","POST", :%data)
    }

    method delete-installation(Int(Str) $installation-id) {
        self.request("/app/installations/$installation-id","DELETE")
    }

    method get-authenticated() {
        self.request("/app","GET")
    }

    method get-by-slug(Str $app-slug) {
        self.request("/apps/$app-slug","GET")
    }

    method get-installation(Int(Str) $installation-id) {
        self.request("/app/installations/$installation-id","GET")
    }

    method get-org-installation(Str $org) {
        self.request("/orgs/$org/installation","GET")
    }

    method get-repo-installation(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/installation","GET")
    }

    method get-user-installation(Str $username) {
        self.request("/users/$username/installation","GET")
    }

    method list-installations(Int(Str) :$per-page, Int(Str) :$page, Str :$since, Str :$outdated) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        %data<since> = $since if defined $since;
        %data<outdated> = $outdated if defined $outdated;
        self.request("/app/installations","GET", :%data)
    }

    method suspend-installation(Int(Str) $installation-id) {
        self.request("/app/installations/$installation-id/suspended","PUT")
    }

    method unsuspend-installation(Int(Str) $installation-id) {
        self.request("/app/installations/$installation-id/suspended","DELETE")
    }

}

