


use WebService::GitHub::Role;

class WebService::GitHub::Apps::Installations  {
    also does WebService::GitHub::Role;
    method add-repo-to-installation(Int(Str) $installation-id, Int(Str) $repository-id) {
        self.request("/user/installations/$installation-id/repositories/$repository-id","PUT")
    }

    method create-content-attachment(Int(Str) $content-reference-id, Str :$body!, Str :$title!) {
        my %data;
        %data<body> = $body;
        %data<title> = $title;
        self.request("/content_references/$content-reference-id/attachments","POST", :%data)
    }

    method list-installation-repos-for-authenticated-user(Int(Str) $installation-id, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/installations/$installation-id/repositories","GET", :%data)
    }

    method list-installations-for-authenticated-user(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/installations","GET", :%data)
    }

    method list-repos-accessible-to-installation(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/installation/repositories","GET", :%data)
    }

    method remove-repo-from-installation(Int(Str) $installation-id, Int(Str) $repository-id) {
        self.request("/user/installations/$installation-id/repositories/$repository-id","DELETE")
    }

    method revoke-installation-access-token() {
        self.request("/installation/token","DELETE")
    }

}

