

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Apps::Marketplace::ListAccountsForPlanDirection of Str where subset-is * eq 'asc'|'desc', 'WebService::GitHub::Apps::Marketplace::ListAccountsForPlanDirection must be either "asc" or "desc"';

subset WebService::GitHub::Apps::Marketplace::ListAccountsForPlanSort of Str where subset-is * eq 'created'|'updated', 'WebService::GitHub::Apps::Marketplace::ListAccountsForPlanSort must be either "created" or "updated"';

subset WebService::GitHub::Apps::Marketplace::ListAccountsForPlanStubbedDirection of Str where subset-is * eq 'asc'|'desc', 'WebService::GitHub::Apps::Marketplace::ListAccountsForPlanStubbedDirection must be either "asc" or "desc"';

subset WebService::GitHub::Apps::Marketplace::ListAccountsForPlanStubbedSort of Str where subset-is * eq 'created'|'updated', 'WebService::GitHub::Apps::Marketplace::ListAccountsForPlanStubbedSort must be either "created" or "updated"';


class WebService::GitHub::Apps::Marketplace  {
    also does WebService::GitHub::Role;
    method get-subscription-plan-for-account(Int(Str) $account-id) {
        self.request("/marketplace_listing/accounts/$account-id","GET")
    }

    method get-subscription-plan-for-account-stubbed(Int(Str) $account-id) {
        self.request("/marketplace_listing/stubbed/accounts/$account-id","GET")
    }

    method list-accounts-for-plan(Int(Str) $plan-id, WebService::GitHub::Apps::Marketplace::ListAccountsForPlanSort :$sort, WebService::GitHub::Apps::Marketplace::ListAccountsForPlanDirection :$direction, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<sort> = $sort if defined $sort;
        %data<direction> = $direction if defined $direction;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/marketplace_listing/plans/$plan-id/accounts","GET", :%data)
    }

    method list-accounts-for-plan-stubbed(Int(Str) $plan-id, WebService::GitHub::Apps::Marketplace::ListAccountsForPlanStubbedSort :$sort, WebService::GitHub::Apps::Marketplace::ListAccountsForPlanStubbedDirection :$direction, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<sort> = $sort if defined $sort;
        %data<direction> = $direction if defined $direction;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/marketplace_listing/stubbed/plans/$plan-id/accounts","GET", :%data)
    }

    method list-plans(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/marketplace_listing/plans","GET", :%data)
    }

    method list-plans-stubbed(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/marketplace_listing/stubbed/plans","GET", :%data)
    }

    method list-subscriptions-for-authenticated-user(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/marketplace_purchases","GET", :%data)
    }

    method list-subscriptions-for-authenticated-user-stubbed(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/marketplace_purchases/stubbed","GET", :%data)
    }

}

