


use WebService::GitHub::Role;

class WebService::GitHub::Apps::OauthApplications  {
    also does WebService::GitHub::Role;
    method check-authorization(Str $client-id, Str $access-token) {
        self.request("/applications/$client-id/tokens/$access-token","GET")
    }

    method check-token(Str $client-id, Str :$access-token!) {
        my %data;
        %data<access_token> = $access-token;
        self.request("/applications/$client-id/token","POST", :%data)
    }

    method delete-authorization(Str $client-id, Str :$access-token) {
        my %data;
        %data<access_token> = $access-token if defined $access-token;
        self.request("/applications/$client-id/grant","DELETE", :%data)
    }

    method delete-token(Str $client-id, Str :$access-token!) {
        my %data;
        %data<access_token> = $access-token;
        self.request("/applications/$client-id/token","DELETE", :%data)
    }

    method reset-authorization(Str $client-id, Str $access-token) {
        self.request("/applications/$client-id/tokens/$access-token","POST")
    }

    method reset-token(Str $client-id, Str :$access-token!) {
        my %data;
        %data<access_token> = $access-token;
        self.request("/applications/$client-id/token","PATCH", :%data)
    }

    method revoke-authorization-for-application(Str $client-id, Str $access-token) {
        self.request("/applications/$client-id/tokens/$access-token","DELETE")
    }

    method revoke-grant-for-application(Str $client-id, Str $access-token) {
        self.request("/applications/$client-id/grants/$access-token","DELETE")
    }

    method scope-token(Str $client-id, Str :$access-token!, Positional :$repository-ids, Associative :$permissions, Positional :$repositories, Int(Str) :$target-id, Str :$target) {
        my %data;
        %data<repository_ids> = $repository-ids if defined $repository-ids;
        %data<access_token> = $access-token;
        %data<permissions> = $permissions if defined $permissions;
        %data<repositories> = $repositories if defined $repositories;
        %data<target_id> = $target-id if defined $target-id;
        %data<target> = $target if defined $target;
        self.request("/applications/$client-id/token/scoped","POST", :%data)
    }

}

