


use WebService::GitHub::Role;

class WebService::GitHub::Checks::Suites  {
    also does WebService::GitHub::Role;
    method create-suite(Str $owner, Str $repo, Str :$head-sha!) {
        my %data;
        %data<head_sha> = $head-sha;
        self.request("/repos/$owner/$repo/check-suites","POST", :%data)
    }

    method get-suite(Str $owner, Str $repo, Int(Str) $check-suite-id) {
        self.request("/repos/$owner/$repo/check-suites/$check-suite-id","GET")
    }

    method list-suites-for-ref(Str $owner, Str $repo, Str $ref, Int(Str) :$app-id, Str :$check-name, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<app_id> = $app-id if defined $app-id;
        %data<check_name> = $check-name if defined $check-name;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/commits/$ref/check-suites","GET", :%data)
    }

    method rerequest-suite(Str $owner, Str $repo, Int(Str) $check-suite-id) {
        self.request("/repos/$owner/$repo/check-suites/$check-suite-id/rerequest","POST")
    }

    method set-suites-preferences(Str $owner, Str $repo, Positional :$auto-trigger-checks) {
        my %data;
        %data<auto_trigger_checks> = $auto-trigger-checks if defined $auto-trigger-checks;
        self.request("/repos/$owner/$repo/check-suites/preferences","PATCH", :%data)
    }

}

