

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::EnterpriseAdmin::AuditLog::GetAuditLogInclude of Str where subset-is * eq 'web'|'git'|'all', 'WebService::GitHub::EnterpriseAdmin::AuditLog::GetAuditLogInclude must be either "web", "git" or "all"';

subset WebService::GitHub::EnterpriseAdmin::AuditLog::GetAuditLogOrder of Str where subset-is * eq 'desc'|'asc', 'WebService::GitHub::EnterpriseAdmin::AuditLog::GetAuditLogOrder must be either "desc" or "asc"';


class WebService::GitHub::EnterpriseAdmin::AuditLog  {
    also does WebService::GitHub::Role;
    method get-audit-log(Str $enterprise, Str :$phrase, WebService::GitHub::EnterpriseAdmin::AuditLog::GetAuditLogInclude :$include, Str :$after, Str :$before, WebService::GitHub::EnterpriseAdmin::AuditLog::GetAuditLogOrder :$order, Int(Str) :$page, Int(Str) :$per-page) {
        my %data;
        %data<phrase> = $phrase if defined $phrase;
        %data<include> = $include if defined $include;
        %data<after> = $after if defined $after;
        %data<before> = $before if defined $before;
        %data<order> = $order if defined $order;
        %data<page> = $page if defined $page;
        %data<per_page> = $per-page if defined $per-page;
        self.request("/enterprises/$enterprise/audit-log","GET", :%data)
    }

}

