


use WebService::GitHub::Role;

class WebService::GitHub::Gists::Comments  {
    also does WebService::GitHub::Role;
    method create-comment(Str $gist-id, Str :$body!) {
        my %data;
        %data<body> = $body;
        self.request("/gists/$gist-id/comments","POST", :%data)
    }

    method delete-comment(Str $gist-id, Int(Str) $comment-id) {
        self.request("/gists/$gist-id/comments/$comment-id","DELETE")
    }

    method get-comment(Str $gist-id, Int(Str) $comment-id) {
        self.request("/gists/$gist-id/comments/$comment-id","GET")
    }

    method list-comments(Str $gist-id, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/gists/$gist-id/comments","GET", :%data)
    }

    method update-comment(Str $gist-id, Int(Str) $comment-id, Str :$body!) {
        my %data;
        %data<body> = $body;
        self.request("/gists/$gist-id/comments/$comment-id","PATCH", :%data)
    }

}

