


use WebService::GitHub::Role;

class WebService::GitHub::Git::Commits  {
    also does WebService::GitHub::Role;
    method create-commit(Str $owner, Str $repo, Str :$message!, Str :$tree!, Associative :$committer, Associative :$author, Str :$signature, Positional :$parents) {
        my %data;
        %data<committer> = $committer if defined $committer;
        %data<message> = $message;
        %data<tree> = $tree;
        %data<author> = $author if defined $author;
        %data<signature> = $signature if defined $signature;
        %data<parents> = $parents if defined $parents;
        self.request("/repos/$owner/$repo/git/commits","POST", :%data)
    }

    method get-commit(Str $owner, Str $repo, Str $commit-sha) {
        self.request("/repos/$owner/$repo/git/commits/$commit-sha","GET")
    }

}

