


use WebService::GitHub::Role;

class WebService::GitHub::Git::Refs  {
    also does WebService::GitHub::Role;
    method create-ref(Str $owner, Str $repo, Str :$ref!, Str :$sha!, Str :$key) {
        my %data;
        %data<ref> = $ref;
        %data<key> = $key if defined $key;
        %data<sha> = $sha;
        self.request("/repos/$owner/$repo/git/refs","POST", :%data)
    }

    method delete-ref(Str $owner, Str $repo, Str $ref) {
        self.request("/repos/$owner/$repo/git/refs/$ref","DELETE")
    }

    method get-ref(Str $owner, Str $repo, Str $ref) {
        self.request("/repos/$owner/$repo/git/ref/$ref","GET")
    }

    method list-matching-refs(Str $owner, Str $repo, Str $ref, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/git/matching-refs/$ref","GET", :%data)
    }

    method update-ref(Str $owner, Str $repo, Str $ref, Str :$sha!, Bool :$force) {
        my %data;
        %data<sha> = $sha;
        %data<force> = $force if defined $force;
        self.request("/repos/$owner/$repo/git/refs/$ref","PATCH", :%data)
    }

}

