

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Git::Tags::CreateTagType of Str where subset-is * eq 'commit'|'tree'|'blob', 'WebService::GitHub::Git::Tags::CreateTagType must be either "commit", "tree" or "blob"';


class WebService::GitHub::Git::Tags  {
    also does WebService::GitHub::Role;
    method create-tag(Str $owner, Str $repo, Str :$message!, Str :$tag!, Str :$object!, WebService::GitHub::Git::Tags::CreateTagType :$type!, Associative :$tagger) {
        my %data;
        %data<message> = $message;
        %data<tagger> = $tagger if defined $tagger;
        %data<tag> = $tag;
        %data<object> = $object;
        %data<type> = $type;
        self.request("/repos/$owner/$repo/git/tags","POST", :%data)
    }

    method get-tag(Str $owner, Str $repo, Str $tag-sha) {
        self.request("/repos/$owner/$repo/git/tags/$tag-sha","GET")
    }

}

