

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Interactions::Orgs::SetRestrictionsForOrgExpiry of Str where subset-is * eq 'one_day'|'three_days'|'one_week'|'one_month'|'six_months', 'WebService::GitHub::Interactions::Orgs::SetRestrictionsForOrgExpiry must be either "one_day", "three_days", "one_week", "one_month" or "six_months"';

subset WebService::GitHub::Interactions::Orgs::SetRestrictionsForOrgLimit of Str where subset-is * eq 'existing_users'|'contributors_only'|'collaborators_only', 'WebService::GitHub::Interactions::Orgs::SetRestrictionsForOrgLimit must be either "existing_users", "contributors_only" or "collaborators_only"';


class WebService::GitHub::Interactions::Orgs  {
    also does WebService::GitHub::Role;
    method get-restrictions-for-org(Str $org) {
        self.request("/orgs/$org/interaction-limits","GET")
    }

    method remove-restrictions-for-org(Str $org) {
        self.request("/orgs/$org/interaction-limits","DELETE")
    }

    method set-restrictions-for-org(Str $org, WebService::GitHub::Interactions::Orgs::SetRestrictionsForOrgLimit :$limit!, WebService::GitHub::Interactions::Orgs::SetRestrictionsForOrgExpiry :$expiry) {
        my %data;
        %data<limit> = $limit;
        %data<expiry> = $expiry if defined $expiry;
        self.request("/orgs/$org/interaction-limits","PUT", :%data)
    }

}

