

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Interactions::Repos::SetRestrictionsForRepoExpiry of Str where subset-is * eq 'one_day'|'three_days'|'one_week'|'one_month'|'six_months', 'WebService::GitHub::Interactions::Repos::SetRestrictionsForRepoExpiry must be either "one_day", "three_days", "one_week", "one_month" or "six_months"';

subset WebService::GitHub::Interactions::Repos::SetRestrictionsForRepoLimit of Str where subset-is * eq 'existing_users'|'contributors_only'|'collaborators_only', 'WebService::GitHub::Interactions::Repos::SetRestrictionsForRepoLimit must be either "existing_users", "contributors_only" or "collaborators_only"';


class WebService::GitHub::Interactions::Repos  {
    also does WebService::GitHub::Role;
    method get-restrictions-for-repo(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/interaction-limits","GET")
    }

    method remove-restrictions-for-repo(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/interaction-limits","DELETE")
    }

    method set-restrictions-for-repo(Str $owner, Str $repo, WebService::GitHub::Interactions::Repos::SetRestrictionsForRepoLimit :$limit!, WebService::GitHub::Interactions::Repos::SetRestrictionsForRepoExpiry :$expiry) {
        my %data;
        %data<expiry> = $expiry if defined $expiry;
        %data<limit> = $limit;
        self.request("/repos/$owner/$repo/interaction-limits","PUT", :%data)
    }

}

