

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Interactions::User::SetRestrictionsForAuthenticatedUserExpiry of Str where subset-is * eq 'one_day'|'three_days'|'one_week'|'one_month'|'six_months', 'WebService::GitHub::Interactions::User::SetRestrictionsForAuthenticatedUserExpiry must be either "one_day", "three_days", "one_week", "one_month" or "six_months"';

subset WebService::GitHub::Interactions::User::SetRestrictionsForAuthenticatedUserLimit of Str where subset-is * eq 'existing_users'|'contributors_only'|'collaborators_only', 'WebService::GitHub::Interactions::User::SetRestrictionsForAuthenticatedUserLimit must be either "existing_users", "contributors_only" or "collaborators_only"';


class WebService::GitHub::Interactions::User  {
    also does WebService::GitHub::Role;
    method get-restrictions-for-authenticated-user() {
        self.request("/user/interaction-limits","GET")
    }

    method remove-restrictions-for-authenticated-user() {
        self.request("/user/interaction-limits","DELETE")
    }

    method set-restrictions-for-authenticated-user(WebService::GitHub::Interactions::User::SetRestrictionsForAuthenticatedUserLimit :$limit!, WebService::GitHub::Interactions::User::SetRestrictionsForAuthenticatedUserExpiry :$expiry) {
        my %data;
        %data<expiry> = $expiry if defined $expiry;
        %data<limit> = $limit;
        self.request("/user/interaction-limits","PUT", :%data)
    }

}

