


use WebService::GitHub::Role;

class WebService::GitHub::Issues::Assignees  {
    also does WebService::GitHub::Role;
    method add-assignees(Str $owner, Str $repo, Int(Str) $issue-number, Positional :$assignees) {
        my %data;
        %data<assignees> = $assignees if defined $assignees;
        self.request("/repos/$owner/$repo/issues/$issue-number/assignees","POST", :%data)
    }

    method check-user-can-be-assigned(Str $owner, Str $repo, Str $assignee) {
        self.request("/repos/$owner/$repo/assignees/$assignee","GET")
    }

    method list-assignees(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/assignees","GET", :%data)
    }

    method remove-assignees(Str $owner, Str $repo, Int(Str) $issue-number, Positional :$assignees) {
        my %data;
        %data<assignees> = $assignees if defined $assignees;
        self.request("/repos/$owner/$repo/issues/$issue-number/assignees","DELETE", :%data)
    }

}

