


use WebService::GitHub::Role;

class WebService::GitHub::Issues::Events  {
    also does WebService::GitHub::Role;
    method get-event(Str $owner, Str $repo, Int(Str) $event-id) {
        self.request("/repos/$owner/$repo/issues/events/$event-id","GET")
    }

    method list-events(Str $owner, Str $repo, Int(Str) $issue-number, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/issues/$issue-number/events","GET", :%data)
    }

    method list-events-for-repo(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/issues/events","GET", :%data)
    }

}

