


use WebService::GitHub::Role;

class WebService::GitHub::Issues::Labels  {
    also does WebService::GitHub::Role;
    method add-labels(Str $owner, Str $repo, Int(Str) $issue-number, Positional :$labels!) {
        my %data;
        %data<labels> = $labels;
        self.request("/repos/$owner/$repo/issues/$issue-number/labels","POST", :%data)
    }

    method create-label(Str $owner, Str $repo, Str :$name!, Str :$description, Str :$color) {
        my %data;
        %data<name> = $name;
        %data<description> = $description if defined $description;
        %data<color> = $color if defined $color;
        self.request("/repos/$owner/$repo/labels","POST", :%data)
    }

    method delete-label(Str $owner, Str $repo, Str $name) {
        self.request("/repos/$owner/$repo/labels/$name","DELETE")
    }

    method get-label(Str $owner, Str $repo, Str $name) {
        self.request("/repos/$owner/$repo/labels/$name","GET")
    }

    method list-labels-for-milestone(Str $owner, Str $repo, Int(Str) $milestone-number, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/milestones/$milestone-number/labels","GET", :%data)
    }

    method list-labels-for-repo(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/labels","GET", :%data)
    }

    method list-labels-on-issue(Str $owner, Str $repo, Int(Str) $issue-number, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/issues/$issue-number/labels","GET", :%data)
    }

    method remove-all-labels(Str $owner, Str $repo, Int(Str) $issue-number) {
        self.request("/repos/$owner/$repo/issues/$issue-number/labels","DELETE")
    }

    method remove-label(Str $owner, Str $repo, Int(Str) $issue-number, Str $name) {
        self.request("/repos/$owner/$repo/issues/$issue-number/labels/$name","DELETE")
    }

    method set-labels(Str $owner, Str $repo, Int(Str) $issue-number, Positional :$labels) {
        my %data;
        %data<labels> = $labels if defined $labels;
        self.request("/repos/$owner/$repo/issues/$issue-number/labels","PUT", :%data)
    }

    method update-label(Str $owner, Str $repo, Str $name, Str :$color, Str :$description, Str :$new-name) {
        my %data;
        %data<color> = $color if defined $color;
        %data<description> = $description if defined $description;
        %data<new_name> = $new-name if defined $new-name;
        self.request("/repos/$owner/$repo/labels/$name","PATCH", :%data)
    }

}

