

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Issues::Milestones::CreateMilestoneState of Str where subset-is * eq 'open'|'closed', 'WebService::GitHub::Issues::Milestones::CreateMilestoneState must be either "open" or "closed"';

subset WebService::GitHub::Issues::Milestones::ListMilestonesDirection of Str where subset-is * eq 'asc'|'desc', 'WebService::GitHub::Issues::Milestones::ListMilestonesDirection must be either "asc" or "desc"';

subset WebService::GitHub::Issues::Milestones::ListMilestonesSort of Str where subset-is * eq 'due_on'|'completeness', 'WebService::GitHub::Issues::Milestones::ListMilestonesSort must be either "due_on" or "completeness"';

subset WebService::GitHub::Issues::Milestones::ListMilestonesState of Str where subset-is * eq 'open'|'closed'|'all', 'WebService::GitHub::Issues::Milestones::ListMilestonesState must be either "open", "closed" or "all"';

subset WebService::GitHub::Issues::Milestones::UpdateMilestoneState of Str where subset-is * eq 'open'|'closed', 'WebService::GitHub::Issues::Milestones::UpdateMilestoneState must be either "open" or "closed"';


class WebService::GitHub::Issues::Milestones  {
    also does WebService::GitHub::Role;
    method create-milestone(Str $owner, Str $repo, Str :$title!, Str :$due-on, WebService::GitHub::Issues::Milestones::CreateMilestoneState :$state, Str :$description) {
        my %data;
        %data<due_on> = $due-on if defined $due-on;
        %data<title> = $title;
        %data<state> = $state if defined $state;
        %data<description> = $description if defined $description;
        self.request("/repos/$owner/$repo/milestones","POST", :%data)
    }

    method delete-milestone(Str $owner, Str $repo, Int(Str) $milestone-number) {
        self.request("/repos/$owner/$repo/milestones/$milestone-number","DELETE")
    }

    method get-milestone(Str $owner, Str $repo, Int(Str) $milestone-number) {
        self.request("/repos/$owner/$repo/milestones/$milestone-number","GET")
    }

    method list-milestones(Str $owner, Str $repo, WebService::GitHub::Issues::Milestones::ListMilestonesState :$state, WebService::GitHub::Issues::Milestones::ListMilestonesSort :$sort, WebService::GitHub::Issues::Milestones::ListMilestonesDirection :$direction, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<state> = $state if defined $state;
        %data<sort> = $sort if defined $sort;
        %data<direction> = $direction if defined $direction;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/milestones","GET", :%data)
    }

    method update-milestone(Str $owner, Str $repo, Int(Str) $milestone-number, Str :$title, Str :$due-on, Str :$description, WebService::GitHub::Issues::Milestones::UpdateMilestoneState :$state) {
        my %data;
        %data<title> = $title if defined $title;
        %data<due_on> = $due-on if defined $due-on;
        %data<description> = $description if defined $description;
        %data<state> = $state if defined $state;
        self.request("/repos/$owner/$repo/milestones/$milestone-number","PATCH", :%data)
    }

}

