


use WebService::GitHub::Role;

class WebService::GitHub::Licenses  {
    also does WebService::GitHub::Role;
    method get(Str $license) {
        self.request("/licenses/$license","GET")
    }

    method get-all-commonly-used(Bool :$featured, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<featured> = $featured if defined $featured;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/licenses","GET", :%data)
    }

    method get-for-repo(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/license","GET")
    }

}

