


use WebService::GitHub::Role;

class WebService::GitHub::Migrations::Orgs  {
    also does WebService::GitHub::Role;
    method delete-archive-for-org(Str $org, Int(Str) $migration-id) {
        self.request("/orgs/$org/migrations/$migration-id/archive","DELETE")
    }

    method download-archive-for-org(Str $org, Int(Str) $migration-id) {
        self.request("/orgs/$org/migrations/$migration-id/archive","GET")
    }

    method get-status-for-org(Str $org, Int(Str) $migration-id, Positional :$exclude) {
        my %data;
        %data<exclude> = $exclude if defined $exclude;
        self.request("/orgs/$org/migrations/$migration-id","GET", :%data)
    }

    method list-for-org(Str $org, Int(Str) :$per-page, Int(Str) :$page, Positional :$exclude) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        %data<exclude> = $exclude if defined $exclude;
        self.request("/orgs/$org/migrations","GET", :%data)
    }

    method list-repos-for-org(Str $org, Int(Str) $migration-id, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/migrations/$migration-id/repositories","GET", :%data)
    }

    method start-for-org(Str $org, Positional :$repositories!, Bool :$exclude-attachments, Positional :$exclude, Bool :$lock-repositories) {
        my %data;
        %data<exclude_attachments> = $exclude-attachments if defined $exclude-attachments;
        %data<exclude> = $exclude if defined $exclude;
        %data<lock_repositories> = $lock-repositories if defined $lock-repositories;
        %data<repositories> = $repositories;
        self.request("/orgs/$org/migrations","POST", :%data)
    }

    method unlock-repo-for-org(Str $org, Int(Str) $migration-id, Str $repo-name) {
        self.request("/orgs/$org/migrations/$migration-id/repos/$repo-name/lock","DELETE")
    }

}

