

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Orgs::OutsideCollaborators::ListOutsideCollaboratorsFilter of Str where subset-is * eq '2fa_disabled'|'all', 'WebService::GitHub::Orgs::OutsideCollaborators::ListOutsideCollaboratorsFilter must be either "2fa_disabled" or "all"';


class WebService::GitHub::Orgs::OutsideCollaborators  {
    also does WebService::GitHub::Role;
    method convert-member-to-outside-collaborator(Str $org, Str $username) {
        self.request("/orgs/$org/outside_collaborators/$username","PUT")
    }

    method list-outside-collaborators(Str $org, WebService::GitHub::Orgs::OutsideCollaborators::ListOutsideCollaboratorsFilter :$filter, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<filter> = $filter if defined $filter;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/outside_collaborators","GET", :%data)
    }

    method remove-outside-collaborator(Str $org, Str $username) {
        self.request("/orgs/$org/outside_collaborators/$username","DELETE")
    }

}

