


use WebService::GitHub::Role;

class WebService::GitHub::Orgs::Webhooks  {
    also does WebService::GitHub::Role;
    method create-webhook(Str $org, Associative :$config!, Str :$name!, Bool :$active, Positional :$events) {
        my %data;
        %data<active> = $active if defined $active;
        %data<events> = $events if defined $events;
        %data<config> = $config;
        %data<name> = $name;
        self.request("/orgs/$org/hooks","POST", :%data)
    }

    method delete-webhook(Str $org, Int(Str) $hook-id) {
        self.request("/orgs/$org/hooks/$hook-id","DELETE")
    }

    method get-webhook(Str $org, Int(Str) $hook-id) {
        self.request("/orgs/$org/hooks/$hook-id","GET")
    }

    method get-webhook-config-for-org(Str $org, Int(Str) $hook-id) {
        self.request("/orgs/$org/hooks/$hook-id/config","GET")
    }

    method list-webhooks(Str $org, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/hooks","GET", :%data)
    }

    method ping-webhook(Str $org, Int(Str) $hook-id) {
        self.request("/orgs/$org/hooks/$hook-id/pings","POST")
    }

    method update-webhook(Str $org, Int(Str) $hook-id, Str :$name, Positional :$events, Bool :$active, Associative :$config) {
        my %data;
        %data<name> = $name if defined $name;
        %data<events> = $events if defined $events;
        %data<active> = $active if defined $active;
        %data<config> = $config if defined $config;
        self.request("/orgs/$org/hooks/$hook-id","PATCH", :%data)
    }

    method update-webhook-config-for-org(Str $org, Int(Str) $hook-id, Str :$content-type, Str :$insecure-ssl, Str :$secret, Str :$url) {
        my %data;
        %data<content_type> = $content-type if defined $content-type;
        %data<insecure_ssl> = $insecure-ssl if defined $insecure-ssl;
        %data<secret> = $secret if defined $secret;
        %data<url> = $url if defined $url;
        self.request("/orgs/$org/hooks/$hook-id/config","PATCH", :%data)
    }

}

