

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Projects::Cards::ListCardsArchivedState of Str where subset-is * eq 'all'|'archived'|'not_archived', 'WebService::GitHub::Projects::Cards::ListCardsArchivedState must be either "all", "archived" or "not_archived"';


class WebService::GitHub::Projects::Cards  {
    also does WebService::GitHub::Role;
    method create-card(Int(Str) $column-id) {
        self.request("/projects/columns/$column-id/cards","POST")
    }

    method delete-card(Int(Str) $card-id) {
        self.request("/projects/columns/cards/$card-id","DELETE")
    }

    method get-card(Int(Str) $card-id) {
        self.request("/projects/columns/cards/$card-id","GET")
    }

    method list-cards(Int(Str) $column-id, WebService::GitHub::Projects::Cards::ListCardsArchivedState :$archived-state, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<archived_state> = $archived-state if defined $archived-state;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/projects/columns/$column-id/cards","GET", :%data)
    }

    method move-card(Int(Str) $card-id, Str :$position!, Int(Str) :$column-id) {
        my %data;
        %data<column_id> = $column-id if defined $column-id;
        %data<position> = $position;
        self.request("/projects/columns/cards/$card-id/moves","POST", :%data)
    }

    method update-card(Int(Str) $card-id, Bool :$archived, Str :$note) {
        my %data;
        %data<archived> = $archived if defined $archived;
        %data<note> = $note if defined $note;
        self.request("/projects/columns/cards/$card-id","PATCH", :%data)
    }

}

