

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Projects::Collaborators::AddCollaboratorPermission of Str where subset-is * eq 'read'|'write'|'admin', 'WebService::GitHub::Projects::Collaborators::AddCollaboratorPermission must be either "read", "write" or "admin"';

subset WebService::GitHub::Projects::Collaborators::ListCollaboratorsAffiliation of Str where subset-is * eq 'outside'|'direct'|'all', 'WebService::GitHub::Projects::Collaborators::ListCollaboratorsAffiliation must be either "outside", "direct" or "all"';


class WebService::GitHub::Projects::Collaborators  {
    also does WebService::GitHub::Role;
    method add-collaborator(Int(Str) $project-id, Str $username, WebService::GitHub::Projects::Collaborators::AddCollaboratorPermission :$permission) {
        my %data;
        %data<permission> = $permission if defined $permission;
        self.request("/projects/$project-id/collaborators/$username","PUT", :%data)
    }

    method get-permission-for-user(Int(Str) $project-id, Str $username) {
        self.request("/projects/$project-id/collaborators/$username/permission","GET")
    }

    method list-collaborators(Int(Str) $project-id, WebService::GitHub::Projects::Collaborators::ListCollaboratorsAffiliation :$affiliation, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<affiliation> = $affiliation if defined $affiliation;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/projects/$project-id/collaborators","GET", :%data)
    }

    method remove-collaborator(Int(Str) $project-id, Str $username) {
        self.request("/projects/$project-id/collaborators/$username","DELETE")
    }

}

