


use WebService::GitHub::Role;

class WebService::GitHub::Projects::Columns  {
    also does WebService::GitHub::Role;
    method create-column(Int(Str) $project-id, Str :$name!) {
        my %data;
        %data<name> = $name;
        self.request("/projects/$project-id/columns","POST", :%data)
    }

    method delete-column(Int(Str) $column-id) {
        self.request("/projects/columns/$column-id","DELETE")
    }

    method get-column(Int(Str) $column-id) {
        self.request("/projects/columns/$column-id","GET")
    }

    method list-columns(Int(Str) $project-id, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/projects/$project-id/columns","GET", :%data)
    }

    method move-column(Int(Str) $column-id, Str :$position!) {
        my %data;
        %data<position> = $position;
        self.request("/projects/columns/$column-id/moves","POST", :%data)
    }

    method update-column(Int(Str) $column-id, Str :$name!) {
        my %data;
        %data<name> = $name;
        self.request("/projects/columns/$column-id","PATCH", :%data)
    }

}

