


use WebService::GitHub::Role;

class WebService::GitHub::Pulls::ReviewRequests  {
    also does WebService::GitHub::Role;
    method list-requested-reviewers(Str $owner, Str $repo, Int(Str) $pull-number, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/pulls/$pull-number/requested_reviewers","GET", :%data)
    }

    method remove-requested-reviewers(Str $owner, Str $repo, Int(Str) $pull-number, Positional :$reviewers!, Positional :$team-reviewers) {
        my %data;
        %data<team_reviewers> = $team-reviewers if defined $team-reviewers;
        %data<reviewers> = $reviewers;
        self.request("/repos/$owner/$repo/pulls/$pull-number/requested_reviewers","DELETE", :%data)
    }

    method request-reviewers(Str $owner, Str $repo, Int(Str) $pull-number, Positional :$team-reviewers, Positional :$reviewers) {
        my %data;
        %data<team_reviewers> = $team-reviewers if defined $team-reviewers;
        %data<reviewers> = $reviewers if defined $reviewers;
        self.request("/repos/$owner/$repo/pulls/$pull-number/requested_reviewers","POST", :%data)
    }

}

