

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Reactions::CreateForCommitCommentContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForCommitCommentContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::CreateForIssueCommentContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForIssueCommentContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::CreateForIssueContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForIssueContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::CreateForPullRequestReviewCommentContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForPullRequestReviewCommentContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::CreateForTeamDiscussionCommentInOrgContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForTeamDiscussionCommentInOrgContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::CreateForTeamDiscussionCommentLegacyContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForTeamDiscussionCommentLegacyContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::CreateForTeamDiscussionInOrgContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForTeamDiscussionInOrgContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::CreateForTeamDiscussionLegacyContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::CreateForTeamDiscussionLegacyContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForCommitCommentContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForCommitCommentContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForIssueCommentContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForIssueCommentContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForIssueContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForIssueContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForPullRequestReviewCommentContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForPullRequestReviewCommentContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForTeamDiscussionCommentInOrgContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForTeamDiscussionCommentInOrgContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForTeamDiscussionCommentLegacyContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForTeamDiscussionCommentLegacyContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForTeamDiscussionInOrgContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForTeamDiscussionInOrgContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';

subset WebService::GitHub::Reactions::ListForTeamDiscussionLegacyContent of Str where subset-is * eq '+1'|'-1'|'laugh'|'confused'|'heart'|'hooray'|'rocket'|'eyes', 'WebService::GitHub::Reactions::ListForTeamDiscussionLegacyContent must be either "+1", "-1", "laugh", "confused", "heart", "hooray", "rocket" or "eyes"';


class WebService::GitHub::Reactions  {
    also does WebService::GitHub::Role;
    method create-for-commit-comment(Str $owner, Str $repo, Int(Str) $comment-id, WebService::GitHub::Reactions::CreateForCommitCommentContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/repos/$owner/$repo/comments/$comment-id/reactions","POST", :%data)
    }

    method create-for-issue(Str $owner, Str $repo, Int(Str) $issue-number, WebService::GitHub::Reactions::CreateForIssueContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/repos/$owner/$repo/issues/$issue-number/reactions","POST", :%data)
    }

    method create-for-issue-comment(Str $owner, Str $repo, Int(Str) $comment-id, WebService::GitHub::Reactions::CreateForIssueCommentContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/repos/$owner/$repo/issues/comments/$comment-id/reactions","POST", :%data)
    }

    method create-for-pull-request-review-comment(Str $owner, Str $repo, Int(Str) $comment-id, WebService::GitHub::Reactions::CreateForPullRequestReviewCommentContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/repos/$owner/$repo/pulls/comments/$comment-id/reactions","POST", :%data)
    }

    method create-for-team-discussion-comment-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, Int(Str) $comment-number, WebService::GitHub::Reactions::CreateForTeamDiscussionCommentInOrgContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments/$comment-number/reactions","POST", :%data)
    }

    method create-for-team-discussion-comment-legacy(Int(Str) $team-id, Int(Str) $discussion-number, Int(Str) $comment-number, WebService::GitHub::Reactions::CreateForTeamDiscussionCommentLegacyContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/teams/$team-id/discussions/$discussion-number/comments/$comment-number/reactions","POST", :%data)
    }

    method create-for-team-discussion-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, WebService::GitHub::Reactions::CreateForTeamDiscussionInOrgContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/reactions","POST", :%data)
    }

    method create-for-team-discussion-legacy(Int(Str) $team-id, Int(Str) $discussion-number, WebService::GitHub::Reactions::CreateForTeamDiscussionLegacyContent :$content!) {
        my %data;
        %data<content> = $content;
        self.request("/teams/$team-id/discussions/$discussion-number/reactions","POST", :%data)
    }

    method delete-for-commit-comment(Str $owner, Str $repo, Int(Str) $comment-id, Int(Str) $reaction-id) {
        self.request("/repos/$owner/$repo/comments/$comment-id/reactions/$reaction-id","DELETE")
    }

    method delete-for-issue(Str $owner, Str $repo, Int(Str) $issue-number, Int(Str) $reaction-id) {
        self.request("/repos/$owner/$repo/issues/$issue-number/reactions/$reaction-id","DELETE")
    }

    method delete-for-issue-comment(Str $owner, Str $repo, Int(Str) $comment-id, Int(Str) $reaction-id) {
        self.request("/repos/$owner/$repo/issues/comments/$comment-id/reactions/$reaction-id","DELETE")
    }

    method delete-for-pull-request-comment(Str $owner, Str $repo, Int(Str) $comment-id, Int(Str) $reaction-id) {
        self.request("/repos/$owner/$repo/pulls/comments/$comment-id/reactions/$reaction-id","DELETE")
    }

    method delete-for-team-discussion(Str $org, Str $team-slug, Int(Str) $discussion-number, Int(Str) $reaction-id) {
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/reactions/$reaction-id","DELETE")
    }

    method delete-for-team-discussion-comment(Str $org, Str $team-slug, Int(Str) $discussion-number, Int(Str) $comment-number, Int(Str) $reaction-id) {
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments/$comment-number/reactions/$reaction-id","DELETE")
    }

    method delete-legacy(Int(Str) $reaction-id) {
        self.request("/reactions/$reaction-id","DELETE")
    }

    method list-for-commit-comment(Str $owner, Str $repo, Int(Str) $comment-id, WebService::GitHub::Reactions::ListForCommitCommentContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/comments/$comment-id/reactions","GET", :%data)
    }

    method list-for-issue(Str $owner, Str $repo, Int(Str) $issue-number, WebService::GitHub::Reactions::ListForIssueContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/issues/$issue-number/reactions","GET", :%data)
    }

    method list-for-issue-comment(Str $owner, Str $repo, Int(Str) $comment-id, WebService::GitHub::Reactions::ListForIssueCommentContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/issues/comments/$comment-id/reactions","GET", :%data)
    }

    method list-for-pull-request-review-comment(Str $owner, Str $repo, Int(Str) $comment-id, WebService::GitHub::Reactions::ListForPullRequestReviewCommentContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/pulls/comments/$comment-id/reactions","GET", :%data)
    }

    method list-for-team-discussion-comment-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, Int(Str) $comment-number, WebService::GitHub::Reactions::ListForTeamDiscussionCommentInOrgContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments/$comment-number/reactions","GET", :%data)
    }

    method list-for-team-discussion-comment-legacy(Int(Str) $team-id, Int(Str) $discussion-number, Int(Str) $comment-number, WebService::GitHub::Reactions::ListForTeamDiscussionCommentLegacyContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/teams/$team-id/discussions/$discussion-number/comments/$comment-number/reactions","GET", :%data)
    }

    method list-for-team-discussion-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, WebService::GitHub::Reactions::ListForTeamDiscussionInOrgContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/reactions","GET", :%data)
    }

    method list-for-team-discussion-legacy(Int(Str) $team-id, Int(Str) $discussion-number, WebService::GitHub::Reactions::ListForTeamDiscussionLegacyContent :$content, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<content> = $content if defined $content;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/teams/$team-id/discussions/$discussion-number/reactions","GET", :%data)
    }

}

