

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Repos::Collaborators::AddCollaboratorPermission of Str where subset-is * eq 'pull'|'push'|'admin'|'maintain'|'triage', 'WebService::GitHub::Repos::Collaborators::AddCollaboratorPermission must be either "pull", "push", "admin", "maintain" or "triage"';

subset WebService::GitHub::Repos::Collaborators::ListCollaboratorsAffiliation of Str where subset-is * eq 'outside'|'direct'|'all', 'WebService::GitHub::Repos::Collaborators::ListCollaboratorsAffiliation must be either "outside", "direct" or "all"';


class WebService::GitHub::Repos::Collaborators  {
    also does WebService::GitHub::Role;
    method add-collaborator(Str $owner, Str $repo, Str $username, Str :$permissions, WebService::GitHub::Repos::Collaborators::AddCollaboratorPermission :$permission) {
        my %data;
        %data<permissions> = $permissions if defined $permissions;
        %data<permission> = $permission if defined $permission;
        self.request("/repos/$owner/$repo/collaborators/$username","PUT", :%data)
    }

    method check-collaborator(Str $owner, Str $repo, Str $username) {
        self.request("/repos/$owner/$repo/collaborators/$username","GET")
    }

    method get-collaborator-permission-level(Str $owner, Str $repo, Str $username) {
        self.request("/repos/$owner/$repo/collaborators/$username/permission","GET")
    }

    method list-collaborators(Str $owner, Str $repo, WebService::GitHub::Repos::Collaborators::ListCollaboratorsAffiliation :$affiliation, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<affiliation> = $affiliation if defined $affiliation;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/collaborators","GET", :%data)
    }

    method remove-collaborator(Str $owner, Str $repo, Str $username) {
        self.request("/repos/$owner/$repo/collaborators/$username","DELETE")
    }

}

