


use WebService::GitHub::Role;

class WebService::GitHub::Repos::Comments  {
    also does WebService::GitHub::Role;
    method create-commit-comment(Str $owner, Str $repo, Str $commit-sha, Str :$body!, Int(Str) :$line, Int(Str) :$position, Str :$path) {
        my %data;
        %data<body> = $body;
        %data<line> = $line if defined $line;
        %data<position> = $position if defined $position;
        %data<path> = $path if defined $path;
        self.request("/repos/$owner/$repo/commits/$commit-sha/comments","POST", :%data)
    }

    method delete-commit-comment(Str $owner, Str $repo, Int(Str) $comment-id) {
        self.request("/repos/$owner/$repo/comments/$comment-id","DELETE")
    }

    method get-commit-comment(Str $owner, Str $repo, Int(Str) $comment-id) {
        self.request("/repos/$owner/$repo/comments/$comment-id","GET")
    }

    method list-comments-for-commit(Str $owner, Str $repo, Str $commit-sha, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/commits/$commit-sha/comments","GET", :%data)
    }

    method list-commit-comments-for-repo(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/comments","GET", :%data)
    }

    method update-commit-comment(Str $owner, Str $repo, Int(Str) $comment-id, Str :$body!) {
        my %data;
        %data<body> = $body;
        self.request("/repos/$owner/$repo/comments/$comment-id","PATCH", :%data)
    }

}

