


use WebService::GitHub::Role;

class WebService::GitHub::Repos::Commits  {
    also does WebService::GitHub::Role;
    method compare-commits(Str $owner, Str $repo, Str $base, Str $head) {
        self.request("/repos/$owner/$repo/compare/$base...$head","GET")
    }

    method get-commit(Str $owner, Str $repo, Str $ref, Int(Str) :$page, Int(Str) :$per-page) {
        my %data;
        %data<page> = $page if defined $page;
        %data<per_page> = $per-page if defined $per-page;
        self.request("/repos/$owner/$repo/commits/$ref","GET", :%data)
    }

    method list-branches-for-head-commit(Str $owner, Str $repo, Str $commit-sha) {
        self.request("/repos/$owner/$repo/commits/$commit-sha/branches-where-head","GET")
    }

    method list-commits(Str $owner, Str $repo, Str :$sha, Str :$path, Str :$author, Str :$since, Str :$until, Int(Str) :$per-page, Int(Str) :$page, Str :$top, Str :$last-sha) {
        my %data;
        %data<sha> = $sha if defined $sha;
        %data<path> = $path if defined $path;
        %data<author> = $author if defined $author;
        %data<since> = $since if defined $since;
        %data<until> = $until if defined $until;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        %data<top> = $top if defined $top;
        %data<last_sha> = $last-sha if defined $last-sha;
        self.request("/repos/$owner/$repo/commits","GET", :%data)
    }

    method list-pull-requests-associated-with-commit(Str $owner, Str $repo, Str $commit-sha, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/commits/$commit-sha/pulls","GET", :%data)
    }

}

