


use WebService::GitHub::Role;

class WebService::GitHub::Repos::Contents  {
    also does WebService::GitHub::Role;
    method create-or-update-file-contents(Str $owner, Str $repo, Str $path, Str :$message!, Str :$content!, Str :$branch, Str :$sha, Associative :$author, Associative :$committer) {
        my %data;
        %data<branch> = $branch if defined $branch;
        %data<sha> = $sha if defined $sha;
        %data<author> = $author if defined $author;
        %data<message> = $message;
        %data<content> = $content;
        %data<committer> = $committer if defined $committer;
        self.request("/repos/$owner/$repo/contents/$path","PUT", :%data)
    }

    method delete-file(Str $owner, Str $repo, Str $path, Str :$message!, Str :$sha!, Associative :$committer, Str :$branch, Associative :$author) {
        my %data;
        %data<message> = $message;
        %data<sha> = $sha;
        %data<committer> = $committer if defined $committer;
        %data<branch> = $branch if defined $branch;
        %data<author> = $author if defined $author;
        self.request("/repos/$owner/$repo/contents/$path","DELETE", :%data)
    }

    method download-tarball-archive(Str $owner, Str $repo, Str $ref) {
        self.request("/repos/$owner/$repo/tarball/$ref","GET")
    }

    method download-zipball-archive(Str $owner, Str $repo, Str $ref) {
        self.request("/repos/$owner/$repo/zipball/$ref","GET")
    }

    method get-content(Str $owner, Str $repo, Str $path, Str :$ref) {
        my %data;
        %data<ref> = $ref if defined $ref;
        self.request("/repos/$owner/$repo/contents/$path","GET", :%data)
    }

    method get-readme(Str $owner, Str $repo, Str :$ref) {
        my %data;
        %data<ref> = $ref if defined $ref;
        self.request("/repos/$owner/$repo/readme","GET", :%data)
    }

    method get-readme-from-alt-path(Str $owner, Str $repo, Str $dir, Str :$ref) {
        my %data;
        %data<ref> = $ref if defined $ref;
        self.request("/repos/$owner/$repo/readme/$dir","GET", :%data)
    }

}

