


use WebService::GitHub::Role;

class WebService::GitHub::Repos::Environments  {
    also does WebService::GitHub::Role;
    method create-or-update-environment(Str $owner, Str $repo, Str $environment-name, Positional :$reviewers, Associative :$deployment-branch-policy, Int(Str) :$wait-timer) {
        my %data;
        %data<reviewers> = $reviewers if defined $reviewers;
        %data<deployment_branch_policy> = $deployment-branch-policy if defined $deployment-branch-policy;
        %data<wait_timer> = $wait-timer if defined $wait-timer;
        self.request("/repos/$owner/$repo/environments/$environment-name","PUT", :%data)
    }

    method delete-an-environment(Str $owner, Str $repo, Str $environment-name) {
        self.request("/repos/$owner/$repo/environments/$environment-name","DELETE")
    }

    method get-all-environments(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/environments","GET")
    }

    method get-environment(Str $owner, Str $repo, Str $environment-name) {
        self.request("/repos/$owner/$repo/environments/$environment-name","GET")
    }

}

