

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Repos::Forks::ListForksSort of Str where subset-is * eq 'newest'|'oldest'|'stargazers'|'watchers', 'WebService::GitHub::Repos::Forks::ListForksSort must be either "newest", "oldest", "stargazers" or "watchers"';


class WebService::GitHub::Repos::Forks  {
    also does WebService::GitHub::Role;
    method create-fork(Str $owner, Str $repo, Str :$org, Str :$organization) {
        my %data;
        %data<org> = $org if defined $org;
        %data<organization> = $organization if defined $organization;
        self.request("/repos/$owner/$repo/forks","POST", :%data)
    }

    method list-forks(Str $owner, Str $repo, WebService::GitHub::Repos::Forks::ListForksSort :$sort, Int(Str) :$per-page, Int(Str) :$page, Str :$org, Str :$organization) {
        my %data;
        %data<sort> = $sort if defined $sort;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        %data<org> = $org if defined $org;
        %data<organization> = $organization if defined $organization;
        self.request("/repos/$owner/$repo/forks","GET", :%data)
    }

}

