

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Repos::Invitations::UpdateInvitationPermissions of Str where subset-is * eq 'read'|'write'|'maintain'|'triage'|'admin', 'WebService::GitHub::Repos::Invitations::UpdateInvitationPermissions must be either "read", "write", "maintain", "triage" or "admin"';


class WebService::GitHub::Repos::Invitations  {
    also does WebService::GitHub::Role;
    method accept-invitation(Int(Str) $invitation-id) {
        self.request("/user/repository_invitations/$invitation-id","PATCH")
    }

    method decline-invitation(Int(Str) $invitation-id) {
        self.request("/user/repository_invitations/$invitation-id","DELETE")
    }

    method delete-invitation(Str $owner, Str $repo, Int(Str) $invitation-id) {
        self.request("/repos/$owner/$repo/invitations/$invitation-id","DELETE")
    }

    method list-invitations(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/invitations","GET", :%data)
    }

    method list-invitations-for-authenticated-user(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/repository_invitations","GET", :%data)
    }

    method update-invitation(Str $owner, Str $repo, Int(Str) $invitation-id, WebService::GitHub::Repos::Invitations::UpdateInvitationPermissions :$permissions) {
        my %data;
        %data<permissions> = $permissions if defined $permissions;
        self.request("/repos/$owner/$repo/invitations/$invitation-id","PATCH", :%data)
    }

}

