


use WebService::GitHub::Role;

class WebService::GitHub::Repos::Keys  {
    also does WebService::GitHub::Role;
    method create-deploy-key(Str $owner, Str $repo, Str :$key!, Bool :$read-only, Str :$title) {
        my %data;
        %data<read_only> = $read-only if defined $read-only;
        %data<key> = $key;
        %data<title> = $title if defined $title;
        self.request("/repos/$owner/$repo/keys","POST", :%data)
    }

    method delete-deploy-key(Str $owner, Str $repo, Int(Str) $key-id) {
        self.request("/repos/$owner/$repo/keys/$key-id","DELETE")
    }

    method get-deploy-key(Str $owner, Str $repo, Int(Str) $key-id) {
        self.request("/repos/$owner/$repo/keys/$key-id","GET")
    }

    method list-deploy-keys(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/keys","GET", :%data)
    }

}

