


use WebService::GitHub::Role;

class WebService::GitHub::Repos::Pages  {
    also does WebService::GitHub::Role;
    method create-pages-site(Str $owner, Str $repo, Associative :$source!) {
        my %data;
        %data<source> = $source;
        self.request("/repos/$owner/$repo/pages","POST", :%data)
    }

    method delete-pages-site(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/pages","DELETE")
    }

    method get-latest-pages-build(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/pages/builds/latest","GET")
    }

    method get-pages(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/pages","GET")
    }

    method get-pages-build(Str $owner, Str $repo, Int(Str) $build-id) {
        self.request("/repos/$owner/$repo/pages/builds/$build-id","GET")
    }

    method list-pages-builds(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/pages/builds","GET", :%data)
    }

    method request-pages-build(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/pages/builds","POST")
    }

    method update-information-about-pages-site(Str $owner, Str $repo, :$source!, Bool :$public, Str :$cname) {
        my %data;
        %data<source> = $source;
        %data<public> = $public if defined $public;
        %data<cname> = $cname if defined $cname;
        self.request("/repos/$owner/$repo/pages","PUT", :%data)
    }

}

