

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Repos::Statuses::CreateCommitStatusState of Str where subset-is * eq 'error'|'failure'|'pending'|'success', 'WebService::GitHub::Repos::Statuses::CreateCommitStatusState must be either "error", "failure", "pending" or "success"';


class WebService::GitHub::Repos::Statuses  {
    also does WebService::GitHub::Role;
    method create-commit-status(Str $owner, Str $repo, Str $sha, WebService::GitHub::Repos::Statuses::CreateCommitStatusState :$state!, Str :$target-url, Str :$context, Str :$description) {
        my %data;
        %data<target_url> = $target-url if defined $target-url;
        %data<state> = $state;
        %data<context> = $context if defined $context;
        %data<description> = $description if defined $description;
        self.request("/repos/$owner/$repo/statuses/$sha","POST", :%data)
    }

    method get-combined-status-for-ref(Str $owner, Str $repo, Str $ref, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/commits/$ref/status","GET", :%data)
    }

    method list-commit-statuses-for-ref(Str $owner, Str $repo, Str $ref, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/commits/$ref/statuses","GET", :%data)
    }

}

