

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Repos::Traffic::GetClonesPer of Str where subset-is * eq 'day'|'week', 'WebService::GitHub::Repos::Traffic::GetClonesPer must be either "day" or "week"';

subset WebService::GitHub::Repos::Traffic::GetViewsPer of Str where subset-is * eq 'day'|'week', 'WebService::GitHub::Repos::Traffic::GetViewsPer must be either "day" or "week"';


class WebService::GitHub::Repos::Traffic  {
    also does WebService::GitHub::Role;
    method get-clones(Str $owner, Str $repo, WebService::GitHub::Repos::Traffic::GetClonesPer :$per) {
        my %data;
        %data<per> = $per if defined $per;
        self.request("/repos/$owner/$repo/traffic/clones","GET", :%data)
    }

    method get-top-paths(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/traffic/popular/paths","GET")
    }

    method get-top-referrers(Str $owner, Str $repo) {
        self.request("/repos/$owner/$repo/traffic/popular/referrers","GET")
    }

    method get-views(Str $owner, Str $repo, WebService::GitHub::Repos::Traffic::GetViewsPer :$per) {
        my %data;
        %data<per> = $per if defined $per;
        self.request("/repos/$owner/$repo/traffic/views","GET", :%data)
    }

}

