


use WebService::GitHub::Role;

class WebService::GitHub::Repos::Webhooks  {
    also does WebService::GitHub::Role;
    method create-webhook(Str $owner, Str $repo, Associative :$config!, Str :$name, Bool :$active, Positional :$events) {
        my %data;
        %data<config> = $config;
        %data<name> = $name if defined $name;
        %data<active> = $active if defined $active;
        %data<events> = $events if defined $events;
        self.request("/repos/$owner/$repo/hooks","POST", :%data)
    }

    method delete-webhook(Str $owner, Str $repo, Int(Str) $hook-id) {
        self.request("/repos/$owner/$repo/hooks/$hook-id","DELETE")
    }

    method get-webhook(Str $owner, Str $repo, Int(Str) $hook-id) {
        self.request("/repos/$owner/$repo/hooks/$hook-id","GET")
    }

    method get-webhook-config-for-repo(Str $owner, Str $repo, Int(Str) $hook-id) {
        self.request("/repos/$owner/$repo/hooks/$hook-id/config","GET")
    }

    method list-webhooks(Str $owner, Str $repo, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/repos/$owner/$repo/hooks","GET", :%data)
    }

    method ping-webhook(Str $owner, Str $repo, Int(Str) $hook-id) {
        self.request("/repos/$owner/$repo/hooks/$hook-id/pings","POST")
    }

    method test-push-webhook(Str $owner, Str $repo, Int(Str) $hook-id) {
        self.request("/repos/$owner/$repo/hooks/$hook-id/tests","POST")
    }

    method update-webhook(Str $owner, Str $repo, Int(Str) $hook-id, Associative :$config, Positional :$add-events, Bool :$active, Positional :$remove-events, Positional :$events) {
        my %data;
        %data<config> = $config if defined $config;
        %data<add_events> = $add-events if defined $add-events;
        %data<active> = $active if defined $active;
        %data<remove_events> = $remove-events if defined $remove-events;
        %data<events> = $events if defined $events;
        self.request("/repos/$owner/$repo/hooks/$hook-id","PATCH", :%data)
    }

    method update-webhook-config-for-repo(Str $owner, Str $repo, Int(Str) $hook-id, Str :$content-type, Str :$insecure-ssl, Str :$secret, Str :$url) {
        my %data;
        %data<content_type> = $content-type if defined $content-type;
        %data<insecure_ssl> = $insecure-ssl if defined $insecure-ssl;
        %data<secret> = $secret if defined $secret;
        %data<url> = $url if defined $url;
        self.request("/repos/$owner/$repo/hooks/$hook-id/config","PATCH", :%data)
    }

}

