


use WebService::GitHub::Role;

class WebService::GitHub::Scim  {
    also does WebService::GitHub::Role;
    method delete-user-from-org(Str $org, Str $scim-user-id) {
        self.request("/scim/v2/organizations/$org/Users/$scim-user-id","DELETE")
    }

    method get-provisioning-information-for-user(Str $org, Str $scim-user-id) {
        self.request("/scim/v2/organizations/$org/Users/$scim-user-id","GET")
    }

    method list-provisioned-identities(Str $org, Int(Str) :$startIndex, Int(Str) :$count, Str :$filter) {
        my %data;
        %data<startIndex> = $startIndex if defined $startIndex;
        %data<count> = $count if defined $count;
        %data<filter> = $filter if defined $filter;
        self.request("/scim/v2/organizations/$org/Users","GET", :%data)
    }

    method provision-and-invite-user(Str $org, Positional :$emails!, Associative :$name!, Str :$userName!, Positional :$schemas, Str :$externalId, Positional :$groups, Str :$displayName, Bool :$active) {
        my %data;
        %data<schemas> = $schemas if defined $schemas;
        %data<externalId> = $externalId if defined $externalId;
        %data<emails> = $emails;
        %data<groups> = $groups if defined $groups;
        %data<name> = $name;
        %data<displayName> = $displayName if defined $displayName;
        %data<userName> = $userName;
        %data<active> = $active if defined $active;
        self.request("/scim/v2/organizations/$org/Users","POST", :%data)
    }

    method set-information-for-provisioned-user(Str $org, Str $scim-user-id, Positional :$emails!, Str :$userName!, Associative :$name!, Str :$displayName, Str :$externalId, Positional :$groups, Positional :$schemas, Bool :$active) {
        my %data;
        %data<emails> = $emails;
        %data<displayName> = $displayName if defined $displayName;
        %data<externalId> = $externalId if defined $externalId;
        %data<userName> = $userName;
        %data<groups> = $groups if defined $groups;
        %data<schemas> = $schemas if defined $schemas;
        %data<name> = $name;
        %data<active> = $active if defined $active;
        self.request("/scim/v2/organizations/$org/Users/$scim-user-id","PUT", :%data)
    }

    method update-attribute-for-user(Str $org, Str $scim-user-id, Positional :$Operations!, Positional :$schemas) {
        my %data;
        %data<schemas> = $schemas if defined $schemas;
        %data<Operations> = $Operations;
        self.request("/scim/v2/organizations/$org/Users/$scim-user-id","PATCH", :%data)
    }

}

