

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::SecretScanning::ListAlertsForRepoState of Str where subset-is * eq 'open'|'resolved', 'WebService::GitHub::SecretScanning::ListAlertsForRepoState must be either "open" or "resolved"';

subset WebService::GitHub::SecretScanning::UpdateAlertState of Str where subset-is * eq 'open'|'resolved', 'WebService::GitHub::SecretScanning::UpdateAlertState must be either "open" or "resolved"';


class WebService::GitHub::SecretScanning  {
    also does WebService::GitHub::Role;
    method get-alert(Str $owner, Str $repo, Int(Str) $alert-number) {
        self.request("/repos/$owner/$repo/secret-scanning/alerts/$alert-number","GET")
    }

    method list-alerts-for-repo(Str $owner, Str $repo, WebService::GitHub::SecretScanning::ListAlertsForRepoState :$state, Int(Str) :$page, Int(Str) :$per-page) {
        my %data;
        %data<state> = $state if defined $state;
        %data<page> = $page if defined $page;
        %data<per_page> = $per-page if defined $per-page;
        self.request("/repos/$owner/$repo/secret-scanning/alerts","GET", :%data)
    }

    method update-alert(Str $owner, Str $repo, Int(Str) $alert-number, WebService::GitHub::SecretScanning::UpdateAlertState :$state!, Str :$resolution) {
        my %data;
        %data<resolution> = $resolution if defined $resolution;
        %data<state> = $state;
        self.request("/repos/$owner/$repo/secret-scanning/alerts/$alert-number","PATCH", :%data)
    }

}

