

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Teams::DiscussionComments::ListDiscussionCommentsInOrgDirection of Str where subset-is * eq 'asc'|'desc', 'WebService::GitHub::Teams::DiscussionComments::ListDiscussionCommentsInOrgDirection must be either "asc" or "desc"';

subset WebService::GitHub::Teams::DiscussionComments::ListDiscussionCommentsLegacyDirection of Str where subset-is * eq 'asc'|'desc', 'WebService::GitHub::Teams::DiscussionComments::ListDiscussionCommentsLegacyDirection must be either "asc" or "desc"';


class WebService::GitHub::Teams::DiscussionComments  {
    also does WebService::GitHub::Role;
    method create-discussion-comment-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, Str :$body!) {
        my %data;
        %data<body> = $body;
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments","POST", :%data)
    }

    method create-discussion-comment-legacy(Int(Str) $team-id, Int(Str) $discussion-number, Str :$body!) {
        my %data;
        %data<body> = $body;
        self.request("/teams/$team-id/discussions/$discussion-number/comments","POST", :%data)
    }

    method delete-discussion-comment-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, Int(Str) $comment-number) {
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments/$comment-number","DELETE")
    }

    method delete-discussion-comment-legacy(Int(Str) $team-id, Int(Str) $discussion-number, Int(Str) $comment-number) {
        self.request("/teams/$team-id/discussions/$discussion-number/comments/$comment-number","DELETE")
    }

    method get-discussion-comment-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, Int(Str) $comment-number) {
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments/$comment-number","GET")
    }

    method get-discussion-comment-legacy(Int(Str) $team-id, Int(Str) $discussion-number, Int(Str) $comment-number) {
        self.request("/teams/$team-id/discussions/$discussion-number/comments/$comment-number","GET")
    }

    method list-discussion-comments-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, WebService::GitHub::Teams::DiscussionComments::ListDiscussionCommentsInOrgDirection :$direction, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<direction> = $direction if defined $direction;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments","GET", :%data)
    }

    method list-discussion-comments-legacy(Int(Str) $team-id, Int(Str) $discussion-number, WebService::GitHub::Teams::DiscussionComments::ListDiscussionCommentsLegacyDirection :$direction, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<direction> = $direction if defined $direction;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/teams/$team-id/discussions/$discussion-number/comments","GET", :%data)
    }

    method update-discussion-comment-in-org(Str $org, Str $team-slug, Int(Str) $discussion-number, Int(Str) $comment-number, Str :$body!) {
        my %data;
        %data<body> = $body;
        self.request("/orgs/$org/teams/$team-slug/discussions/$discussion-number/comments/$comment-number","PATCH", :%data)
    }

    method update-discussion-comment-legacy(Int(Str) $team-id, Int(Str) $discussion-number, Int(Str) $comment-number, Str :$body!) {
        my %data;
        %data<body> = $body;
        self.request("/teams/$team-id/discussions/$discussion-number/comments/$comment-number","PATCH", :%data)
    }

}

