

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Teams::Members::AddOrUpdateMembershipForUserInOrgRole of Str where subset-is * eq 'member'|'maintainer', 'WebService::GitHub::Teams::Members::AddOrUpdateMembershipForUserInOrgRole must be either "member" or "maintainer"';

subset WebService::GitHub::Teams::Members::AddOrUpdateMembershipForUserLegacyRole of Str where subset-is * eq 'member'|'maintainer', 'WebService::GitHub::Teams::Members::AddOrUpdateMembershipForUserLegacyRole must be either "member" or "maintainer"';

subset WebService::GitHub::Teams::Members::ListMembersInOrgRole of Str where subset-is * eq 'member'|'maintainer'|'all', 'WebService::GitHub::Teams::Members::ListMembersInOrgRole must be either "member", "maintainer" or "all"';

subset WebService::GitHub::Teams::Members::ListMembersLegacyRole of Str where subset-is * eq 'member'|'maintainer'|'all', 'WebService::GitHub::Teams::Members::ListMembersLegacyRole must be either "member", "maintainer" or "all"';


class WebService::GitHub::Teams::Members  {
    also does WebService::GitHub::Role;
    method add-member-legacy(Int(Str) $team-id, Str $username) {
        self.request("/teams/$team-id/members/$username","PUT")
    }

    method add-or-update-membership-for-user-in-org(Str $org, Str $team-slug, Str $username, WebService::GitHub::Teams::Members::AddOrUpdateMembershipForUserInOrgRole :$role) {
        my %data;
        %data<role> = $role if defined $role;
        self.request("/orgs/$org/teams/$team-slug/memberships/$username","PUT", :%data)
    }

    method add-or-update-membership-for-user-legacy(Int(Str) $team-id, Str $username, WebService::GitHub::Teams::Members::AddOrUpdateMembershipForUserLegacyRole :$role) {
        my %data;
        %data<role> = $role if defined $role;
        self.request("/teams/$team-id/memberships/$username","PUT", :%data)
    }

    method get-member-legacy(Int(Str) $team-id, Str $username) {
        self.request("/teams/$team-id/members/$username","GET")
    }

    method get-membership-for-user-in-org(Str $org, Str $team-slug, Str $username) {
        self.request("/orgs/$org/teams/$team-slug/memberships/$username","GET")
    }

    method get-membership-for-user-legacy(Int(Str) $team-id, Str $username) {
        self.request("/teams/$team-id/memberships/$username","GET")
    }

    method list-members-in-org(Str $org, Str $team-slug, WebService::GitHub::Teams::Members::ListMembersInOrgRole :$role, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<role> = $role if defined $role;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/teams/$team-slug/members","GET", :%data)
    }

    method list-members-legacy(Int(Str) $team-id, WebService::GitHub::Teams::Members::ListMembersLegacyRole :$role, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<role> = $role if defined $role;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/teams/$team-id/members","GET", :%data)
    }

    method list-pending-invitations-in-org(Str $org, Str $team-slug, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/teams/$team-slug/invitations","GET", :%data)
    }

    method list-pending-invitations-legacy(Int(Str) $team-id, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/teams/$team-id/invitations","GET", :%data)
    }

    method remove-member-legacy(Int(Str) $team-id, Str $username) {
        self.request("/teams/$team-id/members/$username","DELETE")
    }

    method remove-membership-for-user-in-org(Str $org, Str $team-slug, Str $username) {
        self.request("/orgs/$org/teams/$team-slug/memberships/$username","DELETE")
    }

    method remove-membership-for-user-legacy(Int(Str) $team-id, Str $username) {
        self.request("/teams/$team-id/memberships/$username","DELETE")
    }

}

