


use WebService::GitHub::Role;

class WebService::GitHub::Teams::TeamSync  {
    also does WebService::GitHub::Role;
    method create-or-update-idp-group-connections-in-org(Str $org, Str $team-slug, Positional :$groups!) {
        my %data;
        %data<groups> = $groups;
        self.request("/orgs/$org/teams/$team-slug/team-sync/group-mappings","PATCH", :%data)
    }

    method create-or-update-idp-group-connections-legacy(Int(Str) $team-id, Positional :$groups!, Str :$synced-at) {
        my %data;
        %data<synced_at> = $synced-at if defined $synced-at;
        %data<groups> = $groups;
        self.request("/teams/$team-id/team-sync/group-mappings","PATCH", :%data)
    }

    method list-idp-groups-for-legacy(Int(Str) $team-id) {
        self.request("/teams/$team-id/team-sync/group-mappings","GET")
    }

    method list-idp-groups-for-org(Str $org, Int(Str) :$per-page, Str :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/orgs/$org/team-sync/groups","GET", :%data)
    }

    method list-idp-groups-in-org(Str $org, Str $team-slug) {
        self.request("/orgs/$org/teams/$team-slug/team-sync/group-mappings","GET")
    }

}

