

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Users::GetContextForUserSubjectType of Str where subset-is * eq 'organization'|'repository'|'issue'|'pull_request', 'WebService::GitHub::Users::GetContextForUserSubjectType must be either "organization", "repository", "issue" or "pull_request"';


class WebService::GitHub::Users  {
    also does WebService::GitHub::Role;
    method get-authenticated() {
        self.request("/user","GET")
    }

    method get-by-username(Str $username) {
        self.request("/users/$username","GET")
    }

    method get-context-for-user(Str $username, WebService::GitHub::Users::GetContextForUserSubjectType :$subject-type, Str :$subject-id) {
        my %data;
        %data<subject_type> = $subject-type if defined $subject-type;
        %data<subject_id> = $subject-id if defined $subject-id;
        self.request("/users/$username/hovercard","GET", :%data)
    }

    method list(Int(Str) :$since, Int(Str) :$per-page) {
        my %data;
        %data<since> = $since if defined $since;
        %data<per_page> = $per-page if defined $per-page;
        self.request("/users","GET", :%data)
    }

    method update-authenticated(Str :$twitter-username, Str :$name, Str :$blog, Bool :$hireable, Str :$company, Str :$bio, Str :$email, Str :$location) {
        my %data;
        %data<twitter_username> = $twitter-username if defined $twitter-username;
        %data<name> = $name if defined $name;
        %data<blog> = $blog if defined $blog;
        %data<hireable> = $hireable if defined $hireable;
        %data<company> = $company if defined $company;
        %data<bio> = $bio if defined $bio;
        %data<email> = $email if defined $email;
        %data<location> = $location if defined $location;
        self.request("/user","PATCH", :%data)
    }

}

