

use Subset::Helper;
use WebService::GitHub::Role;
subset WebService::GitHub::Users::Emails::SetPrimaryEmailVisibilityForAuthenticatedVisibility of Str where subset-is * eq 'public'|'private', 'WebService::GitHub::Users::Emails::SetPrimaryEmailVisibilityForAuthenticatedVisibility must be either "public" or "private"';


class WebService::GitHub::Users::Emails  {
    also does WebService::GitHub::Role;
    method add-email-for-authenticated() {
        self.request("/user/emails","POST")
    }

    method delete-email-for-authenticated() {
        self.request("/user/emails","DELETE")
    }

    method list-emails-for-authenticated(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/emails","GET", :%data)
    }

    method list-public-emails-for-authenticated(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/public_emails","GET", :%data)
    }

    method set-primary-email-visibility-for-authenticated(WebService::GitHub::Users::Emails::SetPrimaryEmailVisibilityForAuthenticatedVisibility :$visibility!, Str :$email!) {
        my %data;
        %data<visibility> = $visibility;
        %data<email> = $email;
        self.request("/user/email/visibility","PATCH", :%data)
    }

}

