


use WebService::GitHub::Role;

class WebService::GitHub::Users::Followers  {
    also does WebService::GitHub::Role;
    method check-following-for-user(Str $username, Str $target-user) {
        self.request("/users/$username/following/$target-user","GET")
    }

    method check-person-is-followed-by-authenticated(Str $username) {
        self.request("/user/following/$username","GET")
    }

    method follow(Str $username) {
        self.request("/user/following/$username","PUT")
    }

    method list-followed-by-authenticated(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/following","GET", :%data)
    }

    method list-followers-for-authenticated-user(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/followers","GET", :%data)
    }

    method list-followers-for-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/followers","GET", :%data)
    }

    method list-following-for-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/following","GET", :%data)
    }

    method unfollow(Str $username) {
        self.request("/user/following/$username","DELETE")
    }

}

