


use WebService::GitHub::Role;

class WebService::GitHub::Users::GpgKeys  {
    also does WebService::GitHub::Role;
    method create-gpg-key-for-authenticated(Str :$armored-public-key!) {
        my %data;
        %data<armored_public_key> = $armored-public-key;
        self.request("/user/gpg_keys","POST", :%data)
    }

    method delete-gpg-key-for-authenticated(Int(Str) $gpg-key-id) {
        self.request("/user/gpg_keys/$gpg-key-id","DELETE")
    }

    method get-gpg-key-for-authenticated(Int(Str) $gpg-key-id) {
        self.request("/user/gpg_keys/$gpg-key-id","GET")
    }

    method list-gpg-keys-for-authenticated(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/gpg_keys","GET", :%data)
    }

    method list-gpg-keys-for-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/gpg_keys","GET", :%data)
    }

}

