


use WebService::GitHub::Role;

class WebService::GitHub::Users::Keys  {
    also does WebService::GitHub::Role;
    method create-public-ssh-key-for-authenticated(Str :$key!, Str :$title) {
        my %data;
        %data<title> = $title if defined $title;
        %data<key> = $key;
        self.request("/user/keys","POST", :%data)
    }

    method delete-public-ssh-key-for-authenticated(Int(Str) $key-id) {
        self.request("/user/keys/$key-id","DELETE")
    }

    method get-public-ssh-key-for-authenticated(Int(Str) $key-id) {
        self.request("/user/keys/$key-id","GET")
    }

    method list-public-keys-for-user(Str $username, Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/users/$username/keys","GET", :%data)
    }

    method list-public-ssh-keys-for-authenticated(Int(Str) :$per-page, Int(Str) :$page) {
        my %data;
        %data<per_page> = $per-page if defined $per-page;
        %data<page> = $page if defined $page;
        self.request("/user/keys","GET", :%data)
    }

}

